# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2001,2005 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
package CHARM_cli_utils;
#"@(#)12   1.49   src/sam/CHARM/cli/pm/CHARM_cli_utils.pm.perl, charmcli, sam_rsa12pha, rsa12pha0510b 9/3/04 13:09:49"
######################################################################
#                                                                    #
# Package: CHARM_cli_utils.pm                                        #
#                                                                    #
# Description:                                                       #
#   This package contains utility/common subroutines for the         #
#   Cluster High Availability Recovery Manager (CHARM) CLI commands. #
#                                                                    #
# Subroutines Available:                                             #
#                                                                    #
#   error_exit - performs required cleanup and exits with the        #
#     appropriate CHARM CLI error exit code.                         #
#                                                                    #
#   printCIMsg - print common informational message to STDOUT.       #
#     Requires: the program name and message mnemonic as inputs.     #
#                                                                    #
#   printCEMsg - print common error message to STDERR.               #
#     Requires: the program name and message mnemonic as inputs.     #
#                                                                    #
#   call_lsrsrcinfo_command  - Calls the lsrsrcapi C command to      #
#     retrieve attributes of specific classes and resources.         #
#     Requires:                                                      #   
#                                                                    #
#   parse_lsrsrcapi_output  - parses the output from lsrsrcapi       #  
#     command and returns all the missing resources                  #
#     Requires:  output array from lsrsrcapi                         #   
#                                                                    #
#   display_missing_resources - Displays resources that were not     #
#     found in their respective classes.                             #
#     Requires: Missing Resources                                    #   
#                                                                    #
#   check_if_handles_exists - Checks to see if concerned handles     #
#     already exist in the desired class attribute.                  #
#     Requires: Resource Required flag and handles.                  #   
#                                                                    #
#   remove_resources     - Remove a resource or resources using      #
#     RMC CLI commands.                                              #
#     Requires: options, resource class and selection string.        #   
#                                                                    #
#   change_resources     - Changes a resource attribute of the       #
#     of the specified resource class using the RMC CLI comand.      #
#     Requires: options, selection string,resource class  and the    #
#     attributes options.                                            #
#                                                                    #
#   reset_resources     - Resets  specified resources using the RMC  #
#     CLI command "resetrsrc".                                       #
#     Requires: options, selection string,resource class  and the    #
#     attributes options.                                            #
#                                                                    #
#   check_if_resources_exists - Checks to see if specified resources #
#     exists in the specified resource class.                        #
#     Requires: resource class name, and the list of resources.      #
#                                                                    #
#   get_resourcehandles- Retrives the Resource handles for either    #
#     selection strings or  resources. Displays missing resources    #
#     Requires: Selection string Option and Input for lsrsrcapi cmd. #
#                                                                    #
#   get_current_attribute_val - Gets the current value of the desired#
#     attribute from its class.                                      # 
#     Requires: Trace option, resource class name and the desired at-#
#               tribute name.                                        #
#                                                                    #
#   gen_new_attributelist - Generates new list for the desired attri-#
#     butes from the array of resource handles.                      # 
#     Requires:  Attribute name and the array of Resource handles.   #
#                                                                    #
#   parse_resources - This function will generate the operands or    #
#     arguements for resources(equivalencies) to call the lsrsrcapi  # 
#     command.                                                       # 
#     Requires: class, selection string and raw resources.           #
#                                                                    #
#   parse_sourceresources- Function will generate operands or        #
#     arguements for the source resources to call the lsrsrcapi      #
#     command.                                                       # 
#     Requires: Source name,Source string                            #
#                                                                    #
#   check_if_src_rsrc_allowed - This function will check to see if   #
#     the specified handle is a member resource and also if the      #
#     source resource has a relationship is already defined.         #
#     Requires: Source resource handle                               #
#                                                                    #
#   run_list_resources - This function will call the call_lsrsrcinfo #
#     _command function to run the "lsrsrcapi" command , to list     #
#     the attributes of the specified Resource group or member resou-#
#     rses.                                                          #
#     Requires: Attributes, select string, and resource class        #
#                                                                    #
#   run_list_attributes- This function will call the call_lsrsrcinfo #
#     _command function to run the "lsrsrcapi" command , to list     #
#     the attributes of the specified classes.                       #
#     Requires: Attributes, handles                                  #
#                                                                    #
#   get_resource_names - This function will call the call_lsrsrcinfo-#
#     comand function to run the "lsrsrcapi" command, inorder to get #
#     the names or class of specified resource handle or handles.    #
#     Requires: resource handles                                     #
#                                                                    #
#   translate_opstates  - This function will translate the opstate   #
#     integer value to an English translation.                       #
#     Requires: Opstate value                                        #
#                                                                    #
#   translate_relations - This function will translate the relation  #
#     integer value to an English translation.                       #
#     Requires: Relationship value                                   #
#                                                                    #
#   translate_conditions - This function will translate the condition#
#     integer value to an English translation.                       #
#     Requires: Conditional Value                                    #
#                                                                    #
#   retreive_error  - This function will parse the error messages    #
#     from lsrsrcapi and then display it.                            #
#     Requires: err_output                                           #
#                                                                    #
#   gen_new_attrib_list - Generates new list for the desired attribu-#
#     tes from the array of resource handles for the api commands.   # 
#     Requires:  Attribute name and the array of Resource handles.   #
#                                                                    #
#   checkifvalidrelationship - Checks the validity of the relationsh-#
#    ip operand entered at the command line.                         # 
#     Requires:                                                      #
#                                                                    #
#   checkifvalidcondition    - Checks the validity of the condition  #
#     operand entered at the command line.                           # 
#     Requires:                                                      #
#                                                                    #
#   get_attrib_handle_list -This function will retrieve the list     #
#     handles for the specified resource handles.                    #
#     Requires:                                                      #
#                                                                    #
#   parse_targetresources - Parses the command line operand for      #
#     target resources desired for the relationships.                # 
#     Requires:                                                      #
#                                                                    #
#   mkrsrcapi_resources     - Defines one or more resources using the#
#     api command mkrsrc-api.                                        #
#     Requires: options , and attributes                             #    
#                                                                    #
#   rmrsrcapi_resources     - Remove a resource or resources using   #
#     api command rmrsrc-api.                                        #
#     Requires: options, and attributes                              #    
#                                                                    #
#   chrsrcapi_resources     - Changes a resource attribute of one or #
#    more resources using the api command chrsrc-api.                #
#     Requires: options, and attributes options.                     #
#                                                                    #
#   charm_cli_timestamp     - Keeps a log of the syntax used to invo-#
#    ke CHARM configuration commands.                                #
#     Requires: Program name,date and time , and syntax              #
#                                                                    #
#   Rsrc_Is_Fixed  - Function will return TRUE if the resource       #
#     specified is a fixed resource                                  #
#     Requires: Resource Handle                                      #
#                                                                    #
#   get_resource_attributes - This function will retrive the specifi-#
#     ed attribute or attributes for a resource.                     #
#     Requires: Opt_handles, act_attributes, and resource handles.   #    
#                                                                    #
#   runactapi_resources     - Performs a resource action using the   #
#     api command runact-api.                                        #
#     Requires: runact_options                                       #    
#                                                                    #
#   get_fixed_nodenames    -  Function will call the Rsrc_Is_Fixed   #
#     fuction to determine if handles(resources) are fixed. Once     #
#     fixed handles are found node names that they are located at are#
#     determined by calling get_resource_attribute function.         #
#     Requires: Resource Handles                                     #    
#                                                                    #
#   check_if_members_are_allowed  - Function will report members not #
#     belonging to its parents allowed nodes and return members that #
#     can be part of its parent groups allowed nodes.                #
#     Requires:                                                      #
#                                                                    #
#   allowednodeiswhat      -    Function will return the NodeNamelist#
#     of the allowed node attribute of group be it an equivalency or #
#     a node.                                                        #
#     Requires:                                                      #
#                                                                    #
#  replace_chars                                                     #
#     Scans a string respecting multibyte encodings to replace speci-#
#     fic characters with its replacement characters.                #
#                                                                    #
#                                                                    #
#  escape_chars                                                      #
#     Scans a string respecting multibyte encodings to add escapes   #
#     to backslashes (\) and double quotes (").                      #
#                                                                    #
#  unescape_chars                                                    #
#     Scans a string respecting multibyte encodings to change an     #
#     escaped double quote (\") to a double quote (").               #
#                                                                    #
#   getIMsg - returns the text of a message. Used for NLS.           #
#     Requires the program name and message mnemonic as inputs.      #
#                                                                    #
# Examples:                                                          #
#   printCEMsg("EMsgCUcliBadOperand", $rsrc_class);                  #
#                                                                    #
#--------------------------------------------------------------------#
# Inputs:                                                            #
#   /usr/sbin/rsct/msgmaps/samcli.samcli.map - message mapping       #
#                                                                    #
# Outputs:                                                           #
#   stdout - common informational messages that get displayed.       #
#   stderr - common error messages that get displayed.               #
#                                                                    #
# External References:                                               #
#   Commands: ctdspmsg                                               #
#                                                                    #
# Tab Settings:                                                      #
#   4 and tabs should be expanded to spaces before saving this file. #
#   in vi:  (:set ts=4  and   :%!expand -4)                          #
#                                                                    #
# Change Activity:                                                   #
#   010730 JKA 76074: Initial design & write.                        #
#   010820 JKA 76075: Added new function get_specific_handles        #
#                     Fixed function get_selstr_handles              #
#   010910 JKA 76076: Added new function call_lsrsrcinfo_command,    #
#                     gen_operands, display_missing_resources,       #
#                     parse_lsrsrcapi_output,and check_if_handles_-  #
#                     _exists for addrgmbr, chrgmbr, rmrgmbr and lsrg#
#   011008 JKA 76078: Added new function reset_resources and new     #
#                     class name variable $RSRCCTRL.                 #
#   011112 JKA 78242: Added the following new functions:             #
#                       check_if_handles_exists                      #
#                       check_if_resources_exists                    #
#                       get_allowednode_handle                       #
#                       get_resourcehandles                          #
#                       get_current_attribute_val                    # 
#                       gen_new_attributelist                        #
#                       parse_resources                              # 
#                       parse_relationresources                      #
#                       check_if_src_rsrc_allowed                    #
#                     And removed the following functions:           #
#                       find_resource_name                           #
#                       find_resource_handle                         #
#                       get_handle                                   #
#                       get_selstr_handles                           #
#                       get_specific_resource_handles                #
#                     Modified gen_operands and Parse_lsrsrcapi_out- #
#                     put functions to fix the select string query   #
#                     syntax problem.                                #    
#   020114 JKA 79430: Added the following new functions:             #
#                      run_list_resources                            #
#                      get_resource_names                            #
#                      translate_opstates                            #
#                      retreive_error                                #
#                     Modified code to work with new c command       #
#                     lsrsrc-api.                                    #
#   020128 JKA 79854: Added the following new functions( For Multiple#
#                     Instances of a Resource):                      #
#                        checkifvalidrelationship                    #
#                        checkifvalidcondition                       #
#                        gen_new_attrib_list                         #
#                        get_attrib_handle_list                      #
#                        parse_newtargetresources                    #
#                        chrsrcapi_resources                         #
#                        rmrsrcapi_resources                         #
#                        mkrsrcapi_resources                         #
#   020304 JKA 80775: Added the following new functions              #
#                        run_list_relations                          #
#                        translate_relations                         #
#                        translate_conditions                        #
#                       Added checks to identify handles in parse_ls-#
#                     rsrcapi_outputs function when only the class   #
#                     was specified.                                 #
#   020311 JKA 80937: Added -n flag for attr_opts in run_list_resou- #
#                     rces function.                                 #
#                     - Modified code in function get_resource_names #
#                       to handle unknown managed resources (zombies)#
#                       if any.                                      #
#                     - Added Relationship value "Startable" in      #
#                        functions checkifvalidrelationship and      #
#                       translate_relations.                         #
#                     - Removed hostname resolution in function      #
#                       get_allowednode.                             #
#   020325 JKA 81369: Modified chrsrcapi_resources and rmrsrcapi_res-#
#                     ources functions to identify missing or failed #
#                     resources. Added new relationship value "DEPEN-#
#                     ONNCC" and modified code to accomodate it.     #
#                     Simplified code to report xxrsrc-api command   #
#                     errors clearly with less confusion.            #
#                       Added new function charm_cli_timestamp to    #
#                       keep logs of control CHARM commands.         #
#   020415 JKA 81967: Renamed function run_list_relations as run_list#
#                     _attributes. Made changes to list specified at-#
#                     tributes of the specified class. Added code to #
#                     allow aggregate and constituent resources.     #
#                      Added New function Rsrc_Is_Fixed().           #
#   020506 JKA 82664: Changed relationship  DEPENDSONNCC to DEPENDSO-#
#                     NANY. Added more messages to indicate aggregate#
#                     constituent resources. Replced Function parse_-#
#                     relationresources and parse_newtargetresources #
#                     with parse_sourceresources and parse_targetres-#
#                     ources. Changed STARTABLE to ISSTARTABLE.      #
#   020513 JKA 82998: Added new function  "get_resource_attributes"  #
#                     for listing Opstate of Managed Resources and   #
#                     for listing ResourceGroups of Source resources #
#                     in a relationship. Also added function "runact-#
#                     api_resources to perform System Automation Eng-#
#                     ine Actions.                                   #
#   020527 JKA 83397: Added environment variable CT_MANAGEMENT_SCOPE #
#                     to be set to cluster scope to accomodate change#
#                     made by rmc.                                   #
#   020603 JKA 83553: Fixed erraneous report of "Resource type not   #
#                     found" when adding two floater resources.      #
#                     Changes were made in parse_lsrsrc_output funct-#
#                     ion.                                           #
#   020610 JKA 83095: Added function to retreive node names for fixed#
#                     resources only. Resources are passed to this   #
#                     function as handles. After the fixed handles   #
#                     are determined the nodenames that they are act-#
#                     ually located at are found.                    #
#   020624 JKA 83895: Made selection string entry consistent with RMC#
#                     CLI's. Replaced single quote enclosure with do-#
#                     uble quotes. Added "\" to prefix double quotes #
#                     (\")to avoid invalid selection string failures.#
#                     Made minor changes to fix Fixed Node listings. #
#   020701 JKA 84506: Fixed listing invalid fixed resources that res-#
#                     ulted in early exits. The changes were made in #
#                     get_resource_attributes function.              #
#   020715 JKA 84562: Replaced relationship DEPENDONANY to DEPENDSON-#
#                     ANY where required.                            #
#   020715 JKA 84563: Replaced relationship STARTABLE   to ISSTARTAB-#
#                     LE  where required.                            #
#   020729 JKA 84774: Made minor changes to call_lsrsrcinfo_ function#
#                     and get_resourcehandles to handle Error codes  #
#                     from lsrsrc-api command.                       #
#   020820 JKA 85535: Made changes in parse_lsrsrcapi... and         #
#                     get_resourcehandles functions to allow ordered #
#                     policy for equivalency.                        #
#   020903 JKA 86315: Fixed problem with adding resources to equival-#
#                     encies when using select strings. Included res-#
#                     ources into ordered list for select strings in #
#                     parse_lsrsrc..... function. Also fixed         #
#                     defect 86131 ...checking for exact phrase for  #
#                     relatiuonship and condition.                   #
#   020910 JKA 86679: Allowed adding fixed resources with same name  #
#                     from other nodes of the cluster.(changes in fu-# 
#                     nction parse_lsrsrc-api ....)                  #
#   020924 JKA 86767: Function get_resource_names will not exit when #
#                     an unresolved handle is used. Also update func-# 
#                     tion get_allowed_nodes to querry in the NodeN- #
#                     ameList attribute instead of the name attribute#
#   020930 JKA 87438: Replaced occurence of "charmcli" with "samcli" #
#                     to adhere to the renameing of CHARM to SAM(Sys-#
#                     tem automaion).                                #
#   021007 JKA 87472: Made changes to display only "unresolved" when #
#                     finding unresolved resource handles. Removed   #
#                     misleading error message for this defect.      #
#                     (function changed ..get_resource_names)        #
#   021104 JKA 88617: List command will no longer fail even when re- #
#                     sources are listed from nodes that are offline.#
#   030107 JKA 89909: Added two more functions for chrgmbr and addrg-#
#                     mbr commands to control the allowed node const-#
#                     raints for resource group members.             #
#   030211 JKA 91636: Added changes to make_resources function to un-#
#                     set CT_CLI_QUOTE_STRING before calling the mkr-#
#                     src RMC command and setting it again after the #
#                     call is completed.                             #
#   030211 JKA XXXXX: New changes for usability enhancements.        #
#                                                                    #
#                       removed function make_resource.              #
#   030715 JKA 96901: Implemented changes for samdiag command.       #
#                     (exported varrible NotResolved.)               #
#   030731 JKA 97772: Implemented changes for new Relationships      #
#                     STOPSAFTER and FORCEDOWN. Also included the new#
#                     OpState value ineligible.                      #
#   031008 JKA 100233:Added a line of code to not exit when allowed  #
#                     node specified via an input file is invalid.   #
#                     Expected to exit as needed from the called     #
#                     function.                                      #
#   031219 JKA 101099:Fixed error messages recieved from daemon with #
#                     more than one ":".                             #
#   040210 JKA 103374:Exported function Rsrc_Is_Fixed.               #
#   040217 JKA 103930:Replaced FORCEDOWN Relationship with FORCEDOWN-#
#                     BY as per DCR09.                               #
#   040319 JKA 104287:Added message "EMsgCHARMcliFixedRsrcNotMember" #
#                     to clearly indicate that fixed resource is not #
#                     managed resource.                              #
#   040322 JKA 104975:Allowed RG's with at least one common Allowed  #
#                     node with its new parent to be a member,       #
#                     provided at least one of these nodes are also  #
#                     common with the topgroup of the parent group.  #
#   040324 JKA 106148:Minor changes to allow replace config to work  #
#                     with changes made for 104975.                  #
#   040418 JKA 105863:Changes to adjust to x5c japanese charaters.   #
#                     Added functions escape_chars,unescape_chars and#
#                     replace_chars.                                 #
#   040426 JKA 108069:More changes for x5c japanese charaters.       #
#   040426 JKA 108154:Modified code to unescape "\" for x5c changes. #
#   040504 JKA 108207:Modified code to get Messages from samcli.cat. #
#                     Added function getIMsg to retreive messages for#
#                     use in code as variables. (NLS reason)         #
#   050704 MJH 108864 Change FORCEDOWNBY to FORCEDDOWNBY             #
#   050704 JKA 108606 Message from Resource Managers will be printed #
#                     as is to STDERR instead of calling printCEMsg. #
#   040903 MJH 113076:$A0 - Verify exact keyword matches for         #
#                           several keywords                         #
######################################################################

use Exporter ();
@ISA = qw(Exporter);
@EXPORT_OK = qw(
    error_exit
    printCIMsg
    printCEMsg
    call_lsrsrcinfo_command
    gen_operands
    check_if_handles_exists
    get_allowednode_handle
    remove_resources
    change_resources
    reset_resources
    check_if_resources_exists
    get_resourcehandles
    get_current_attribute_val
    gen_new_attributelist
    parse_resources
    parse_sourceresources
    check_if_src_rsrc_allowed
    run_list_resources
    run_list_attributes
    get_resource_names
    get_resource_attributes
    translate_opstates
    translate_relations
    translate_conditions
    translate_policies
    checkifvalidrelationship
    checkifvalidcondition
    gen_new_attrib_list
    get_attrib_handle_list
    parse_targetresources
    chrsrcapi_resources
    rmrsrcapi_resources
    mkrsrcapi_resources
    charm_cli_timestamp
    runactapi_resources
    get_fixed_nodenames
    check_if_members_are_allowed
    allowednodeiswhat
    Rsrc_Is_Fixed
    escape_chars
    unescape_chars
    replace_chars
    getIMsg
    $TRUE $FALSE
    $CTDIR $CTBINDIR
    $RSRCGRP $RSRCMGD $RSRCREL $RSRCNODE $RSRCEQU $RSRCCTRL
    $RMC_CLI_USER_ERROR $NotResolved
    $GARBAGE
);

use lib "/usr/sbin/rsct/pm";
use locale;

use CHARM_cli_rc qw(:return_codes);

#--------------------------------------------------------------------#
# Global Variables                                                   #
#--------------------------------------------------------------------#
$MSGCAT             = "samcli.cat";               # msg catalogue for this cmd
$MSGSET             = "samcli";                   # common message set

$CTDIR              = "/usr/sbin/rsct";           # RSCT root directory
$CTBINDIR           = "$CTDIR/bin";               # Cluster Bin directory path
$LSMSG              = "$CTBINDIR/ctdspmsg";       # list / display message rtn
$ENV{'MSGMAPPATH'}  = "$CTDIR/msgmaps";           # msg maps used by $LSMSG
$ENV{'CT_CLI_QUOTE_STRING'}  = 1;                 # Enable quotes               
$ENV{'CT_MANAGEMENT_SCOPE'}  = 2;                 # cluster Mode                

# Related Resource Classes
$RSRCGRP            = "IBM.ResourceGroup";        # Resourse Group Class
$RSRCMGD            = "IBM.ManagedResource";      # Managed Resource Class
$RSRCREL            = "IBM.ManagedRelationship";  # Managed Relationship Class
$RSRCEQU            = "IBM.Equivalency";          # Equivalency Resource Class
$RSRCNODE           = "IBM.PeerNode";             # Peer Node Resource Class
$RSRCCTRL           = "IBM.CHARMControl";         # CHARM Control Resource Class

# RMC Command Names
$LSRSRC             = "lsrsrc";                   # List resource rmc command
$LSRSRCAPI          = "lsrsrc-api";               # List resource information  
$MKRSRC             = "mkrsrc";                   # Make resource rmc command
$RMRSRC             = "rmrsrc";                   # Remove resource rmc command
$CHRSRC             = "chrsrc";                   # Change resource rmc command
$CHRSRCAPI          = "chrsrc-api";               # Change resource api command
$RMRSRCAPI          = "rmrsrc-api";               # Remove resource api command
$MKRSRCAPI          = "mkrsrc-api";               # Make resource api command
$RSTRSRC            = "resetrsrc";                # Reset resource rmc command
$RUNACTAPI          = "runact-api";               # Change resource api command
$DELIMITER          = "tvtv";                     # a delimiter to use
$GARBAGE            = "/dev/null";                # place to put garbage
$RMC_CLI_USER_ERROR = 5;                          # to check for RMC CLI user error
$RMC_CLI_NO_RSRC_FOUND = 6;                       # RMC CLI no resource error
$LSNOTFND           = 0;                          # number of last index on
                                                  # lsrsrc if no condition found
$EQUIV_ALL = "0x0000 0x0000 0x00000000 0x00000000 0x00000000 0x00000000";
                                                  # Equivalency of all Nodes
$NULL               = "ALL";                       # All Equivalency String
$ERR_MSG            = "/tmp/charm_error";         # Error message from lsrsrcapi
$RMGR_LOG          = "/var/ct/IBM.RecoveryRM.log";# Recovery Manager Log File
$NotResolved        = "Unresolved";       
@handles_ordered     = ();


# Relationship Constants
$COLLOCATED         = 1;                          # Collocated relationship
$ANTICOLLOCATED     = 2;                          # Anti-Collocated relationship
$AFFINITY           = 3;                          # Affinity relationship
$ANTIAFFINITY       = 4;                          # Anti-Affinity relationship
$ISSTARTABLE        = 5;                          # Is Startable relationship
$STARTAFTER         = 6;                          # Startafter relationship
$DEPENDSON          = 7;                          # Dependson relationship
$DEPENDSONANY       = 8;                          # Dependson on with no collocation
$STOPSAFTER         = 9;                          # Dependson relationship
$FORCEDDOWNBY       = 10;                         # Dependson on with no collocation

# Condition Constants
$NOCONDITION        = 0;                          # No condition
$IFONLINE           = 1;                          # If Online condition
$IFOFFLINE          = 2;                          # If Offline condition
$IFNOTONLINE        = 3;                          # If Not Online condition
$IFNOTOFFLINE       = 4;                          # If Not Offline condition

# Policies Constants
$ANY                = 0;                          # Any Policy  
$ORDERED            = 1;                          # Ordered Policy     
$ROUNDROBIN         = 2;                          # Round Robin Policy  

# FIXED RESOURCES
$RMC_RSRC_HNDL_TYPE_FIXED = 0x4000;
$RMC_RSRC_HNDL_TYPE_MASK  = 0x4000;

$FALSE              = 0;
$TRUE               = 1;

#--------------------------------------------------------------------#
# Exported Subroutines (with @EXPORT_OK, -> on demand).              #
#--------------------------------------------------------------------#

#--------------------------------------------------------------------#
# Common message handling (error, informational) routines:           #
#--------------------------------------------------------------------#

#--------------------------------------------------------------------#
# error_exit - performs required cleanup and exits.                  #
# Parameters:                                                        #
#   $badrc                    Bad return code - bad enough to exit   #
#                             processing of this command.            #
# Exit:                                                              #
#   1 CHARM_CLI_RMC_ERROR      Underlying RMC error.                 #
#   2 CHARM_CLI_ERROR          Unexpected error in the command       #
#                              script.                               #
#   3 CHARM_CLI_BAD_FLAG       Input flag error.                     #
#   4 CHARM_CLI_BAD_OPERAND    Input operand error.                  #
#   5 CHARM_CLI_USER_ERROR     User error.                           #
#   6 CHARM_CLI_NO_RSRC_FOUND  No resources found.                   #
#                                                                    #
# Global References:                                                 #
#   $main::Cleanup.           Hash indicating what needs to be       #
#                             cleaned up.                            #
#                             if {Session} defined - value is        #
#                             session that must terminate.           #
#                             terminate.                             #
#--------------------------------------------------------------------#
sub error_exit
{
my ($badrc) = @_;

SWITCH: {
    ($badrc == CHARM_CLI_RMC_ERROR)      && exit($badrc);
    ($badrc == CHARM_CLI_ERROR)          && exit($badrc);
    ($badrc == CHARM_CLI_BAD_FLAG)       && exit($badrc);
    ($badrc == CHARM_CLI_BAD_OPERAND)    && exit($badrc);
    ($badrc == CHARM_CLI_USER_ERROR)     && exit($badrc);
    ($badrc == CHARM_CLI_NO_RSRC_FOUND)  && exit($badrc);
    ($badrc == CHARM_CLI_RSRC_EXISTS)    && exit($badrc);
    # At this point all return codes should have been converted to
    # a valid CHARM CLI return code.  But if one wasn't, write an
    # error message.
    printCEMsg("EMsgCHARMcliBadRC", $badrc);
    exit(CHARM_CLI_ERROR);
}   # end switch

}   # end error_exit


#--------------------------------------------------------------------#
# printCIMsg : Calls $LSMSG to print out the common cluster          #
#   CHARM CLI information messages with the required paramaters.     #
#   Messages printed to stdout.                                      #
#   This subroutine is like printIMsg except it is used to print     #
#   the common CHARM CLI messages which are in the samcli message    #
#   set.                                                             #
#                                                                    #
# Paramaters:                                                        #
#   $msg           Message mnemonic / message number in a sense.     #
#   $optargs       Extra arguments/parameters to send to $LSMSG.     #
#                                                                    #
# Returns:  None.                                                    #
#                                                                    #
# Global Variables:                                                  #
#   $main::Trace        Prints extra info when trace is on.          #
#   $LSMSG              Path & Command to display messages.          #
#   $MSGCAT             MC CLI Message catalogue.                    #
#   $MSGSET             MC CLI common message set "mccli".           #
#--------------------------------------------------------------------#
sub printCIMsg
{
my ($msg, @optargs) = @_;
my ($optarg, $optargs);

$main::Trace &&
    print STDERR "$LSMSG $MSGSET $MSGCAT $msg @optargs\n";

# Keep the args to LSMSG separate by separating with single quotes
# but must replace internal single quotes with blanks or get an error.
# Must escape internal double quotes for the system call.
foreach $optarg (@optargs) {
    $optarg =~ s/'/ /g;
    $optarg =~ s/"/\\"/g;
}
$optargs = "'" . join("' '",@optargs) . "'";

(scalar @optargs > 0) ?
    system "$LSMSG $MSGSET $MSGCAT $msg $optargs" :
    system "$LSMSG $MSGSET $MSGCAT $msg";

return;
}   # end printCIMsg


#--------------------------------------------------------------------#
# printCEMsg : Calls $LSMSG to print out the common cluster          #
#   CHARM CLI error messages with the required paramaters.           #
#   Messages printed to stderr.                                      #
#   This subroutine is like printEMsg except it is used to print     #
#   the common CHARM CLI messages which are in the samcli message    #
#   set and it prefixes the message with the appropriate program     #
#   name.                                                            #
#                                                                    #
# Paramaters:                                                        #
#   $msg           Message mnemonic / message number in a sense.     #
#   $optargs       Extra arguments/parameters to send to $LSMSG.     #
#                                                                    #
# Returns:  None.                                                    #
#                                                                    #
# Global Variables:                                                  #
#   $main::PROGNAME     Calling program/command for error message.   #
#   $main::Trace        Prints extra info when trace is on.          #
#   $LSMSG              Path and command to display messages.        #
#   $MSGCAT             CU CLI Message catalogue.                    #
#   $MSGSET             CU CLI common message set "cucli".           #
#--------------------------------------------------------------------#
sub printCEMsg
{
my ($msg, @optargs) = @_;
my ($optarg, $optargs);

$main::Trace &&
    print STDERR "$LSMSG $MSGSET $MSGCAT $msg $main::PROGNAME @optargs\n";

# Keep the args to LSMSG separate by separating with single quotes
# but must replace internal single quotes with blanks or get an error.
# Must escape internal double quotes for the system call.
foreach $optarg (@optargs) {
    $optarg =~ s/'/ /g;
    $optarg =~ s/"/\\"/g;
}
$optargs = "'" . join("' '",@optargs) . "'";

(scalar @optargs > 0) ?
    system "$LSMSG $MSGSET $MSGCAT $msg $main::PROGNAME $optargs 1>&2" :
    system "$LSMSG $MSGSET $MSGCAT $msg $main::PROGNAME 1>&2";

return;
}   # end printCEMsg


#--------------------------------------------------------------------#
# remove_resources     : Uses the Remove resource RMC CLI command to #
#                        remove an already defined resources for a   #
#                        specified  class                            #
#                                                                    #
# Paramaters:                                                        #
#   $passopts           Options to pass to the RMC(Trace or Verbose) #
#   $select_string      Selection string to be passed to RMC         #
#   $resource_class     resource class name                          #
#                                                                    #
# Returns:                                                           #
#   $rc              return code                                     #
#                    0  if successful                                #
#                    CHARM_CLI_USER_ERROR if RMC_CLI_USER_ERROR      #
#                                                                    #
# Global Variables:                                                  #
#   $main::Trace     in case trace is on                             #
#   $main::PROGNAME  for trace message                               #
#   $CTBINDIR        where remove command resides                    #
#   $RMRSRC          RMC CLI  remove command                         #
#--------------------------------------------------------------------#
sub remove_resources    
{
my $passopts         = shift(@_);         # Trace or Verbose option flags 
my $select_string    = shift(@_);         # selection string
my $resource_class   = shift(@_);         # Resource Class
my $rc               = 0;                 # return code

$main::Trace &&
    print STDERR "$main::PROGNAME: calling $RMRSRC\n";

# make the resources for the specified class, using the "rmrsrc" comand       
`$CTBINDIR/$RMRSRC $passopts $select_string $resource_class`;
$rc = $?;
$rc = $rc/256;

$main::Trace &&
     print STDERR "$main::PROGNAME: $RMRSRC returned $rc\n";

# if rmrsrc command failed due to RMC CLI user error   
# return CHARM CLI user error
if ($rc == $RMC_CLI_USER_ERROR) {
   return(CHARM_CLI_USER_ERROR);
} elsif ($rc == $RMC_CLI_NO_RSRC_FOUND) {
    return(CHARM_CLI_NO_RSRC_FOUND);
}

# if make command failed for any other reason, print RMC error message 
# and exit
if ($rc != 0) {
    printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
    exit(CHARM_CLI_RMC_ERROR);
}

# return rc
return $rc;
} # End remove_resource


#--------------------------------------------------------------------#
# change_resources     : Uses the Change resource RMC CLI command to #
#                        modify an already defined resources for a   #
#                        specified  class                            #
#                                                                    #
# Paramaters:                                                        #
#   $passopts           Options to pass to the RMC(Trace or Verbose) #
#   $select_string      Selection string to be passed to RMC         #
#   $resource_class     resource class name                          #
#   $attropts           Attributes to pass to the RMC                #
#                                                                    #
# Returns:                                                           #
#   $rc              return code                                     #
#                    0  if successful                                #
#                    CHARM_CLI_USER_ERROR if RMC_CLI_USER_ERROR      #
#                                                                    #
# Global Variables:                                                  #
#   $main::Trace     in case trace is on                             #
#   $main::PROGNAME  for trace message                               #
#   $CTBINDIR        where change command resides                    #
#   $RMRSRC          RMC CLI change command                          #
#--------------------------------------------------------------------#
sub change_resources    
{
my $passopts         = shift(@_);         # Trace or Verbose option flags 
my $select_string    = shift(@_);         # selection string
my $resource_class   = shift(@_);         # Resource class name   
my $attropts         = shift(@_);         # attributes for resource
my $rc               = 0;                 # return code

$main::Trace &&
    print STDERR "$main::PROGNAME: calling $CHRSRC\n";

# make the resources for the specified class, using the "chrsrc" comand       
`$CTBINDIR/$CHRSRC $passopts $select_string $resource_class $attropts`;
$rc = $?;
$rc = $rc/256;

$main::Trace &&
     print STDERR "$main::PROGNAME: $CHRSRC returned $rc\n";

# if chrsrc command failed due to RMC CLI user error   
# return CHARM CLI user error
if ($rc == $RMC_CLI_USER_ERROR) {
   return(CHARM_CLI_USER_ERROR);
} elsif ($rc == $RMC_CLI_NO_RSRC_FOUND) {
    return(CHARM_CLI_NO_RSRC_FOUND);
}

# if make command failed for any other reason, print RMC error message 
# and exit
if ($rc != 0) {
    printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
    exit(CHARM_CLI_RMC_ERROR);
}

# return rc
return $rc;
} # End change_resources

#--------------------------------------------------------------------#
# call_lsrsrcinfo_command- Function will call the "lsrsrcapi"       # 
#                          command to find the resourse handles for  #
#                          either all the resources specified or the #
#                          selection string.                         #
#                                                                    #
# Parameters:                                                        #
#   $lsrsrcapi_opts        input   Input for lsrsrcapi             #
#                                                                    #
# Return:                                                            #
#   @lsrsrcapi_output      Output  Output of lsrsrcapi command     #
#                                                                    #
# Global References:                                                 #
#   Trace              input  Trace call & return of extension.      #
#                                                                    #
#--------------------------------------------------------------------#
sub call_lsrsrcinfo_command {

my $lsrsrcapi_opts     = shift @_;
my @lsrsrcapi_output   = ();
my @raw_output    = ();
my $RH_output     = "";
my $output        = "";
my $junk          = "";
my @new_output    = ();
my $Is_Error      = "";
my @rest_of_output= ();


$main::Trace && print STDERR "$main::PROGNAME: calling $LSRSRCAPI \n";
$main::Trace && print STDERR "$CTBINDIR/$LSRSRCAPI  $lsrsrcapi_opts \n";
# list the resource handle for the selection string,
@lsrsrcapi_output = `$CTBINDIR/$LSRSRCAPI  $lsrsrcapi_opts 2>&1 `;
foreach $output (@lsrsrcapi_output) {
   ($Is_Error,@rest_of_output) = split(/::/,$output);
   if ($Is_Error eq "ERROR") {
       $rc = &retreive_error($LSRSRCAPI ,$output);
$main::Trace && print STDERR "$main::PROGNAME: $LSRSRCAPI  returned $rc\n";
       if ($rc == $RMC_CLI_USER_ERROR) {
           $rc = CHARM_CLI_USER_ERROR;
           printCEMsg("EMsgCHARMcliUserError",$rc);
#           return($rc,@new_output);
       } elsif ($rc == $RMC_CLI_NO_RSRC_FOUND) {
           $rc = CHARM_CLI_NO_RSRC_FOUND;
#           printCEMsg("EMsgCHARMcliNoRsrcFound",$rc);
#           return($rc,@new_output);
       } elsif ($rc != 0) {
           # if command failed for other reason, print RMC error message
           $rc =CHARM_CLI_RMC_ERROR;
           printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
#           return($rc,@new_output);
       }
    } elsif ($Is_Error =~ /^$CTBINDIR/) {
       printCEMsg("EMsgCHARMclisrcapiError",$output);
       $rc = $?;
       $rc = $rc/256;
#       return($rc,@new_output);
    }else {
       push @new_output, $output;
    }
} # foreach

# if there's output returned from the list, the resource_handle exists
# set $rc accordingly
if ((scalar @new_output) > $LSNOTFND) {  # resources found
    $rc = 0;
}
else {                                    # resources not found
    if($rc == 0) { 
      $rc = CHARM_CLI_NO_RSRC_FOUND;
    }
}
# return the hash back as references
return ($rc, @new_output);
}    # end call_lsrsrcinfo_command 

#--------------------------------------------------------------------#
# gen_operands          - function to parse the resource operand and #
#                         to generate operands for the lsrsrcapi    #
#                         command. It will parse  the "," DELIMITTER #
#                         to seperate resources of the same class. It#
#                         will also parse the ":" DELIMITTER to      #
#                         seperate resources from the Node operand   #
#                         for fixed resources if present.            #
# Parameters:                                                        #
#   $Opt_SelectString input   Select String option.                  #
#   %member_resources input   Raw Member Resource data               #
#                                                                    #
#                                                                    #
# Return:                                                            #
#   @actual_resources     All the specified resources for this       #
#                         class.                                     #
#   $lsrsrcapi_opts      String containing operands for lsrsrcinf   #
#                         command.                                   #
#                                                                    #
# Global References:                                                 #
#                                                                    #
#--------------------------------------------------------------------#
sub gen_operands
{
my $Opt_SelectString    = shift @_;
my (%member_resources)  = @_;
my $resource_class      = "";
my $lsrsrcapi_opts     = " ";
my $selection_string    = "";
my $node                = "";
my @resources           = ();
my $resource            = "";
my $act_resource        = "";
my @actual_resources    = ();
my @raw_resources       = ();
my @all_resources       = ();
my $resource_count      = 0;
my $info_flags          = " -i -e ";



# get the class and resources
foreach $resource_class (keys %member_resources) {
    # when Selection string is specified
    if ($Opt_SelectString) {
         $lsrsrcapi_opts = $lsrsrcapi_opts .  " ";

        # get all selection string for this class
        @actual_resources = @{$member_resources{$resource_class}};

        # seperating resources
        foreach $selection_string (@actual_resources) {
            if ($resource_count == 0) {
               $lsrsrcapi_opts = $lsrsrcapi_opts . " -e -i ";
               $lsrsrcapi_opts = $lsrsrcapi_opts . "-a Name::ResourceHandle ";
            }
            $lsrsrcapi_opts = $lsrsrcapi_opts . " -s " . $resource_class;
            # make sure the single and double quotes are prefixed by "\"
            #$lsrsrcapi_opts = $lsrsrcapi_opts . "::" . "\'" . $selection_string . "\'";
            $lsrsrcapi_opts = $lsrsrcapi_opts . "::" . "\"" . $selection_string . "\"";
            ++ $resource_count;
        } # foreach $resource
    }
    else {

        # get all resources for this class
        @raw_resources = @{$member_resources{$resource_class}};
     
        # seperating resources
        foreach $resource (@raw_resources) {
            @resources = split (/,/, $resource);
            foreach $act_resource(@resources) {
                push @all_resources, $act_resource;
            }
        }
        # When only classes are specified without any resources
        if((scalar @all_resources) > 0) {
           # Generate the lsrsrcapi opts
           foreach $resource (@all_resources) {
     
               $lsrsrcapi_opts = $lsrsrcapi_opts . " -o " . $resource_class;
               ($act_resource, $node) = split (/:/, $resource);
               #push the resource and node to the hash member_resources
               push @actual_resources, $act_resource;
               $lsrsrcapi_opts = $lsrsrcapi_opts . "::" . "\"$act_resource\"";
               if (defined($node))  {
                   $lsrsrcapi_opts  = $lsrsrcapi_opts . "::" . $node;
               }
           } 
        } else {
               $info_flags = " -i -m -a Name::ResourceHandle ";
               $lsrsrcapi_opts = $lsrsrcapi_opts . " -o " . $resource_class;
        }
    } # else
    #Reset for next class
    @all_resources = ();
} # foreach

unless ($Opt_SelectString) {
    $info_flags .= $lsrsrcapi_opts;
    $lsrsrcapi_opts = $info_flags;
}
return($lsrsrcapi_opts, @actual_resources);
} # End gen_operands

#--------------------------------------------------------------------#
# parse_lsrsrcapi_outputs - function to parse the lsrsrcapi command#
#                            output. It will parse  the "::"         #
#                            DELIMITTER to seperate resource Handles #
#                            from the output.                        #
#                            Missing Resourse handles will also be   #
#                            recorded for display later.             #
#                                                                    #
# Parameters:                                                        #
#   $lsrsrcapi_output input  Output from lsrsrcapi command         #
#   $Opt_SelectString input   Select String option.                  #
#                                                                    #
#                                                                    #
# Return:                                                            #
#   @actual_handles           All the available resource handles     #
#                                                                    #
# Global References:                                                 #
#                                                                    #
#--------------------------------------------------------------------#
sub parse_lsrsrcapi_outputs
{
my $Opt_SelectString    = shift @_;
my (@lsrsrcapi_output)  = @_;
my %missing_resources   = ();
my $output              = "";
my $resource_class      = "";
my $handle              = "";
my %actual_handles      = ();
my $lsrsrcapi_opts      = "";
my $selection_string    = "";
my $act_resource        = "";
my $node                = "";
my $resource            = "";
my $junk                = "";
my $MissingRsrce        = $FALSE;
my $count               = 0;
my $previous_class      = "";     
my $previous_resource   = "";               
my $previous_handle     = "";     
my $previous_node       = "";     
my $previous_type       = "";      
my $FIXED               = 0;      
my $AGGREGATE           = 1;     
my $RSRC_SAVED          = $FALSE;
my $ExpectedType        = $AGGREGATE; 
my $WasExpecting        = $AGGREGATE; 
my $CurrHandleType      = $AGGREGATE;

@handles_ordered        = ();
foreach $output (@lsrsrcapi_output) {
    chomp($output);
    $count = 0;
    if ($Opt_SelectString) {
        # seperating resources
        $count++ while $output =~ /(::)/g;
        if ($count == 3) {
                ($resource_class,$selection_string,$act_resource,$handle) = split(/::/,$output);
        } else {
                ($resource_class,$selection_string,$handle) = split(/::/,$output);
        }
        if (($handle eq "") || (!defined $handle)) {
            $MissingRsrce = $TRUE;
            push (@{$missing_resources{$resource_class}}, $selection_string);
        }
        else {
            $handle = "\"$handle\"";
            #push the handles to the list of handles found.
            $actual_handles{$handle} = $act_resource;
            push @handles_ordered, $handle; 
        }
    }
    else {
        # seperating resources
        $count++ while $output =~ /(::)/g;
        $node = "";
        if ($count == 3) {
                ($resource_class,$act_resource,$node,$handle) = split(/::/, $output);
        } elsif ($count == 2) {
                ($resource_class,$act_resource,$handle) = split(/::/, $output);
        } else {
                ($resource_class,$handle) = split(/::/, $output);
        }
        # Remove the double quotes from resource name
        #($junk, $act_resource) = split (/"/,$act_resource);
        if (($handle eq "") || (!defined $handle)) {
            $MissingRsrce = $TRUE;
            push (@{$missing_resources{$resource_class}}, $act_resource);
        }
        else {
            unless (($node eq "")&&(!defined $main::Opt_AnyType)) {
                $ExpectedType = $FIXED;
            } else { $ExpectedType =$AGGREGATE; }
            # For aggregate & constituent Resources
            if(Rsrc_Is_Fixed($handle)) { 
               $main::Trace &&
               print STDERR "$main::PROGNAME: $act_resource is a Fixed Resource\n";
               $CurrHandleType = $FIXED; 
            } else {
               $main::Trace &&
               print STDERR "$main::PROGNAME: $act_resource is a Floating Resource\n";
               $CurrHandleType = $AGGREGATE; 
            }
            if ($ExpectedType == $CurrHandleType){
                if(($resource_class eq $previous_class)
                  && ($act_resource eq $previous_resource)
                  &&($previous_type == $CurrHandleType)) {
                     if(($RSRC_SAVED)&&(!defined $main::Opt_ListCmd)) {
                        if((($previous_node eq $node)
                           &&($CurrHandleType == $FIXED))
                           ||($CurrHandleType == $AGGREGATE)){
                              printCEMsg("EMsgCHARMcliNoMultipleTypes",$act_resource ,$resource_class);
                              exit(CHARM_CLI_USER_ERROR);
                        }
                        #push the resource to the hash member_resources
                        $previous_class   = $resource_class;
                        $previous_resource= $act_resource;
                        $previous_handle  = $handle;
                        $previous_node    = $node;
                        $handle = "\"$handle\"";
                        $actual_handles{$handle} = $act_resource;
                        push @handles_ordered, $handle; 
                        $previous_type    = $CurrHandleType;
                        $RSRC_SAVED  = $TRUE; 
                     } else {
                        #push the resource to the hash member_resources
                        $previous_class   = $resource_class;
                        $previous_resource= $act_resource;
                        $previous_handle  = $handle;
                        $previous_node    = $node;
                        $handle = "\"$handle\"";
                        $actual_handles{$handle} = $act_resource;
                        push @handles_ordered, $handle; 
                        $previous_type    = $CurrHandleType;
                        $RSRC_SAVED  = $TRUE; 
                    }
                 } else {  
                    if(($resource_class ne $previous_class)
                      ||($act_resource ne $previous_resource)){
                         unless($RSRC_SAVED) {
                           if($previous_class ne "") { 
                               printCIMsg("IMsgCHARMcliNoRsrcType",$main::PROGNAME,$previous_resource,$previous_class);
                            }  
                          }
                      }
                      #push the resource to the hash member_resources
                      $previous_class   = $resource_class;
                      $previous_resource= $act_resource;
                      $previous_handle  = $handle;
                      $previous_node    = $node;
                      $handle = "\"$handle\"";
                      $actual_handles{$handle} = $act_resource;
                        push @handles_ordered, $handle; 
                      $previous_type    = $CurrHandleType;
                      $RSRC_SAVED  = $TRUE; 
                }
            } else {
              if(($resource_class eq $previous_class)
                  && ($act_resource eq $previous_resource)) {
                     $previous_class   = $resource_class;
                     $previous_resource= $act_resource;
                     $previous_handle  = $handle;
                     $previous_node    = $node;
                     $handle = "\"$handle\"";
                     $previous_type    = $CurrHandleType;
                     $WasExpecting = $ExpectedType; 
              } elsif(($resource_class ne $previous_class)
                ||($act_resource ne $previous_resource)){
                   unless($RSRC_SAVED) {
                       if($previous_class ne "") { 
                          printCIMsg("IMsgCHARMcliNoRsrcType",$main::PROGNAME,$previous_resource,$previous_class);
                       }  
                   }
                   $previous_class   = $resource_class;
                   $previous_resource= $act_resource;
                   $previous_handle  = $handle;
                   $previous_node    = $node;
                   $handle = "\"$handle\"";
                   $previous_type    = $CurrHandleType;
                   $WasExpecting = $ExpectedType; 
                   $RSRC_SAVED  = $FALSE 
               }
           } 
 
         }
     }
  }
return ($MissingRsrce, \%actual_handles,\%missing_resources);
} # End parse_lsrsrcapi_outputs

#--------------------------------------------------------------------#
# display_missing_resources - Function will display all the missing  #
#                             resources that were not found in the   #
#                             specified class.                       # 
#                                                                    #
# Parameters:                                                        #
#   Opt_SelectString   input  Selection string as input to command   #
#   %missing_resources input  Missing resources                      #
#                                                                    #
# Return:              None                                          #
#                                                                    #
# Global References:                                                 #
#   Trace              input  Trace call & return of extension.      #
#                                                                    #
#--------------------------------------------------------------------#
sub display_missing_resources {

my $Opt_SelectString    = shift @_;
my %missing_resources = @_;
my @resources        = ();
my $resource_class   = "";
my $resource         = "";

# Display all missing resources
foreach $resource_class (keys %missing_resources){
   @resources = @{$missing_resources{$resource_class}};
   foreach $resource (@resources) {
      if ($Opt_SelectString){
          printCEMsg("EMsgCHARMcliNoSelectionResource",$resource,$resource_class);
      }
      else {
          printCEMsg("EMsgCHARMcliResourceNotFound",$resource,$resource_class);
      }
   } # foreach $resource
} # foreach $resource_class

} #End display_missing_resources

#--------------------------------------------------------------------#
# Check_if_handles_exist  This function will get the list of actual  #
#                         handles that match the specified resources #
#                         or selection string and are not  members   #
#                         of the  concerned resource Group.          #
#                                                                    #
# Parameters:                                                        #
#   $resource_group   input   Rresource group                        #
#   %all_resources    input   Hash containing resource name & handles#
#                                                                    #
# Return:                                                            #
#   $good_handles    Output   List of actual member handles.         #
#                                                                    #
# Global References:                                                 #
#   Trace             input  Trace call & return of extension.       #
#   $RSRCMGD          input  Managed Resource class.                 #
#                                                                    #
#--------------------------------------------------------------------#
sub check_if_handles_exists {

my $HasToExist         = shift @_;
my $resource_group     = shift @_;
my %all_resources      = @_;
my @actual_handles     = ();
my @resources          = ();
my @good_handles       = ();
my $resource           = "";
my $handle             = "";
my $act_handle         = "";
my $select_string      = "";
my $lsrsrcapi_input         = " -i ";
my $attribute          = " ManagedResource::MemberOf";
my $count              = 0;
my $rc                 = 0;
my $ResourcesPresent   = $FALSE;
my $ResourcesNotPresent = $FALSE;
my $present            = $FALSE;
my %mgd_resources      = ();
my $output             = "";
my $group              = "";
my @node_names         = ();
my @nonmgd_resources   = ();


# generate the select string to verify if resource handle exists
$select_string = $select_string . "'";
foreach $handle (keys %all_resources) {
    if ($count != 0) {
        $select_string = $select_string . " or ";
    }
    if (($HasToExist)&&!($resource_group eq "")) {
        $select_string = $select_string . "MemberOf == \"$resource_group\" and ";
    }
    $select_string = $select_string . "ManagedResource==$handle";
    ++$count;
}
$select_string = $select_string . "'";

$lsrsrcapi_input = $lsrsrcapi_input . " -a $attribute -s $RSRCMGD". "::$select_string";

($rc,@actual_handles) = &call_lsrsrcinfo_command($lsrsrcapi_input);
# return CHARM CLI user error if it's an RMC CLI user error
($rc == CHARM_CLI_USER_ERROR) && ( error_exit(CHARM_CLI_USER_ERROR) );

# from chrgmbr
if ($rc == CHARM_CLI_NO_RSRC_FOUND) {
    if ($HasToExist) {
      if ($resource_group eq "") {
 	printCEMsg("EMsgCHARMcliRsrcAllNotMembers");
      } else {
        printCEMsg("EMsgCHARMcliMemberRsrcAllNotPresent", $resource_group);
      }
      #exit(CHARM_CLI_NO_RSRC_FOUND);
      return ($rc,$ResourcesPresent, $ResourcesNotPresent,@good_handles);
    }
    else {
        @good_handles = (keys %all_resources);
        $rc = 0;
        return ($rc,$ResourcesPresent, $ResourcesNotPresent,@good_handles);
    }
}

foreach $output (@actual_handles) {
     chomp ($output);
     ($handle,$group) = split(/::/,$output);
     $handle = "\"$handle\"";
   $group =~ s/"//g ; 
     $mgd_resources{$handle} = $group;
}

#Reset count
$count = 0;

# Resource name
@resources = (values %all_resources);

# Compare handles
foreach $handle (keys %all_resources) {
    chomp($handle);
    $resource = $resources[$count];
    foreach $act_handle (keys %mgd_resources) {
        chomp($act_handle);
        if ($handle eq $act_handle) {
            $present = $TRUE;
            if ($HasToExist) {
                push @good_handles, $act_handle;
            } else {
                $ResourcesPresent = $TRUE;
                printCEMsg("EMsgCHARMcliMemberRsrcPresent",$resource,$mgd_resources{$act_handle});
            }
            last;
        }
    }

# Resource is not present
if ($present == $FALSE){
    $ResourcesNotPresent = $TRUE;
    if ($HasToExist) {
        if ($resource_group eq ""){
            my $rsrchndl = $handle;
            $rsrchndl =~ s/"//g;
            if(Rsrc_Is_Fixed($rsrchndl)) { 
                @nonmgd_resources = ();
                push @nonmgd_resources , $rsrchndl;
                my $Opt_HandlesSaved = $Opt_Handles;
                unless ($Opt_Handles){
                   $Opt_Handles = $TRUE;
                }
                (@node_names) = get_fixed_nodenames($Opt_Handles,@nonmgd_resources);
                printCEMsg("EMsgCHARMcliFixedRsrcNotMember",$resource, $node_names[0]);
                $Opt_Handles = $Opt_HandlesSaved;
            } else {
                printCEMsg("EMsgCHARMcliRsrcNotMember",$resource);
            }

        } else {
            printCEMsg("EMsgCHARMcliMemberRsrcNotPresent",$resource,$resource_group);
        }
    } else {
        push @good_handles, $handle;
    }
}
++$count;
#Reset "resource not present" for next handle
$present = $FALSE;

}
if ($HasToExist) {
    $rc = 0;
   #return ($rc,$ResourcesPresent, $ResourcesNotPresent,@good_handles);
} else {
    if ($ResourcesNotPresent){
       $rc = 0;
    #   return ($rc,$ResourcesPresent, $ResourcesNotPresent,@good_handles);
    } else {
        #printCEMsg("EMsgCHARMcliMemberRsrcAllPresent");
        #exit(CHARM_CLI_RSRC_EXISTS);
        $rc = CHARM_CLI_RSRC_EXISTS;
    #    return ($rc,$ResourcesPresent, $ResourcesNotPresent,@good_handles);
    }
}
return ($rc,$ResourcesPresent, $ResourcesNotPresent,@good_handles);

} #End check_if_handle_exists

#--------------------------------------------------------------------#
# reset_resources     : Uses the reset resource RMC CLI command to   #
#                       reset the specified resources.               #
#                                                                    #
#                                                                    #
# Paramaters:                                                        #
#   $passopts           Options to pass to the RMC(Trace or Verbose) #
#   $select_string      selection string                             #
#   $resource_class     resource class name                          #
#   $attropts           Attributes to pass to the RMC                #
#                                                                    #
# Returns:                                                           #
#   $rc              return code                                     #
#                    0  if successful                                #
#                    CHARM_CLI_USER_ERROR if RMC_CLI_USER_ERROR      #
#                                                                    #
# Global Variables:                                                  #
#   $main::Trace     in case trace is on                             #
#   $main::PROGNAME  for trace message                               #
#   $CTBINDIR        where change command resides                    #
#   $RSTRSRC         RMC reset command                               #
#--------------------------------------------------------------------#
sub reset_resources    
{
my $passopts         = shift(@_);         # Trace or Verbose option flags 
my $select_string    = shift(@_);         # Selection string      
my $resource_class   = shift(@_);         # Resource class name
my $attropts         = shift(@_);         # attributes for resource
my $rc               = 0;                 # return code

$main::Trace &&
    print STDERR "$main::PROGNAME: calling $RSTRSRC\n";

# make the resources for the specified class, using the "mkrsrc" comand       
`$CTBINDIR/$RSTRSRC $select_string $passopts $resource_class $attropts`;
$rc = $?;
$rc = $rc/256;

$main::Trace &&
     print STDERR "$main::PROGNAME: $RSTRSRC returned $rc\n";

# if mkrsrc command failed due to RMC CLI user error   
# return CHARM CLI user error
if ($rc == $RMC_CLI_USER_ERROR) {
   return(CHARM_CLI_USER_ERROR);
} elsif ($rc == $RMC_CLI_NO_RSRC_FOUND) {
    return(CHARM_CLI_NO_RSRC_FOUND);
}

# if make command failed for any other reason, print RMC error message 
# and exit
if ($rc != 0) {
    printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
    exit(CHARM_CLI_RMC_ERROR);
}

# return rc
return $rc;
} # End reset_resources


#--------------------------------------------------------------------#
# check_if_resources_exists: This function will check to see if the  #
#                            specified resources exist in the specif-#
#                            ied class.                              #
#                                                                    #
# Paramaters:                                                        #
#   $class              Resource class name                          #
#   @resource_group     List of resource groups                      #
#                                                                    #
# Returns:                                                           #
#   $rc                 return code                                  #
#   @missing_rgroup     list of the missing resource groups          #
#   @existing_rgroup    list of the existing resource groups         #
#                                                                    #
# Global Variables:                                                  #
#   $main::Trace        in case trace is on                          #
#   $main::PROGNAME     for trace message                            #
#--------------------------------------------------------------------#
sub check_if_resources_exists {

my $class             = shift @_;
my $Opt_String        = shift @_;
my $string_opts       = shift @_;
my @resources         = @_;
my $info_opts         = " -i -e -a Name";
my $lsrsrcapi_opts   = "";
my @lsrsrcapi_output = ();
my @missing_rsrcs     = ();
my @existing_rsrcs    = ();
my $resource          = "";
my $resource_name     = "";
my $junk              = "";
my $rclass            = "";
my $rname             = "";
my $MissingResource   = $FALSE;
my $ExistingResource  = $FALSE;
my $output            = "";
my $rc                = 0;

if ($Opt_String) {
    $lsrsrcapi_opts = $info_opts . " -s ";
    $lsrsrcapi_opts .= $class . "::" . "$string_opts";

} else {
    $lsrsrcapi_opts = $info_opts;
    foreach $resource (@resources) {
       $lsrsrcapi_opts .= " -o " . $class . "::" . "\"$resource\"";
    }
}

# call lsrsrc info
($rc,@lsrsrcapi_output) = &call_lsrsrcinfo_command($lsrsrcapi_opts);
if ($rc == CHARM_CLI_NO_RSRC_FOUND) {
    return(CHARM_CLI_NO_RSRC_FOUND,@resources, @existing_rsrcs);
}

# return CHARM CLI user error if it's an RMC CLI user error
($rc == CHARM_CLI_USER_ERROR) && ( error_exit(CHARM_CLI_USER_ERROR) );

# Removed on 11/01/02
# if lsrsrcapi command failed, print error message
#if ($rc != 0) {
#    printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
#    exit(CHARM_CLI_RMC_ERROR);
#}


foreach $output (@lsrsrcapi_output) {
    chomp ($output);
    ($rclass, $resource, $rname) = split(/::/,$output);
    if (($rname eq "") || (!defined $rname)) {
        $MissingResource = $TRUE;
        push @missing_rsrcs,$resource;
    } else {
        $ExistingResource = $TRUE;
        ($junk, $resource_name) = split(/"/,$rname);
        push @existing_rsrcs,$resource_name;
    }
}

if ($MissingResource != $TRUE) {
    $rc = CHARM_CLI_RSRC_EXISTS;
} elsif ($ExistingResource != $TRUE){
    $rc = CHARM_CLI_NO_RSRC_FOUND;
}
return ($rc, \@missing_rsrcs, \@existing_rsrcs );
} # end check_if_resource_exists

#--------------------------------------------------------------------#
# get_allowednode_handle - This function will retreive Resource Hand-#
#                          les for node names or Equivaleny name from#
#                          their respective classs. The node name if #
#                          not in long format will be converted to   #
#                          long hostname if possible.                #
#                                                                    #
# Input:                                                             #
#   $node_name              Node or equivalency name for allowed node#
#                                                                    #
# Return:                                                            #
#   $node_handle             Resource handle for node or equivalency #
#                                                                    #
# Global Variables used:                                             #
#   $Verbose                 Verbose mode on.                        #
#   $Trace                   Trace mode on.                          #
#   $main::Opt_Nodes         Node name specified.                    #
#--------------------------------------------------------------------#
sub get_allowednode_handle
{

my $node_name          = shift @_;
my $resource_class     = shift @_;             # Resource class
my $hname              = "";                   # long host name
my $haliases           = "";                   # host aliases
my $haddrtype          = "";                   # host address type
my $hlength            = "";                   # host length
my @haddrs             = "";                   # host address
my $allowed_node       = "";                   # Allowed node name
my $node_handle        = "";                   # Node Resource Handle
my $handle             = "";                   # Resource Handle
my $lsrsrcapi_input   = "";                   # Input parameter to lsrsrcapi
my @lsrsrcapi_output  = ();                   # Output from lsrsrcapi

#if node name is specified
#if ($main::Opt_Nodes) {
#    ($hname, $haliases, $haddrtype, $hlength, @haddrs) = gethostbyname($node_name);

    # use long name if exists, otherwise keep short name
#    if (!$hname) { $allowed_node = $node_name; }
#    else { $allowed_node = $hname; }
#}
#else {
#    $allowed_node   = $node_name;
#}

 # lsrsrcapi input
 if ($main::Opt_Nodes) {
     $allowed_node   = "\"$node_name\"";
     $lsrsrcapi_input = " -s $resource_class" . "::" . "\'$allowed_node in NodeNameList\'";
 } else {
     #$allowed_node   = $node_name;
     $lsrsrcapi_input = " -i -o $resource_class" . "::" . $node_name;

 }
#get the Resource handle of Node name
($rc,@lsrsrcapi_output) = &call_lsrsrcinfo_command($lsrsrcapi_input);

# verify Return Code
if ($rc == CHARM_CLI_USER_ERROR) {
    exit(CHARM_CLI_USER_ERROR);
}
if ($rc == CHARM_CLI_NO_RSRC_FOUND) {
  unless($main::Opt_IgnoreMissingNode){
    if ($main::Opt_Nodes) {
        printCEMsg("EMsgCHARMcliNodeDoesNotExist",$node_name);
        exit(CHARM_CLI_NO_RSRC_FOUND);
    }
    else {
        printCEMsg("EMsgCHARMcliEquivalencyDoesNotExist",$node_name);
        exit(CHARM_CLI_NO_RSRC_FOUND);
    }
  }  
}

# Removed on 11/01/02
# if anything else, print RMC error message and exit
#if ($rc != 0) {
#    printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
#    exit(CHARM_CLI_RMC_ERROR);
#}

foreach $handle (@lsrsrcapi_output) {
     chomp ($handle);
     $node_handle = "\"$handle\"";
}
# Return to main
return $node_handle;
} # end get_allowednode_handles

#--------------------------------------------------------------------#
# get_resourcehandles    - This function will retreive Resource Hand-#
#                          les for resources from the specified clas-#
#                          ses. It will report all the missing resou-#
#                          ces in their respective classes and conti-#
#                          nue to get handles for the remaining reso-#
#                          urces if any. If more than one source res-#
#                          ource is found or specified then that con-#
#                          dition will be recorded and returned.     #
#                                                                    #
# Input:                                                             #
#   $Opt_SelectString   Input  Selection String Option               #
#   $lsrsrcapi_opts    Input  Input arguements for lsrsrcapi comma-#
#                              nd.                                   #
#                                                                    #
# Return:                                                            #
#   %all_resources           Hash containing Resource name and handle#
#                                                                    #
# Global Variables used:                                             #
#   $Verbose                 Verbose mode on.                        #
#   $Trace                   Trace mode on.                          #
#   $Opt_ResourceExist       At least one resource Exist.            #
#   $Opt_TooManySource       Too Many Source resources were specified#
#--------------------------------------------------------------------#
sub get_resourcehandles {

my $Opt_SelectString  = shift @_;
my ($lsrsrcapi_opts) = @_;
my %all_resources     = ();
my %missing_resources = ();
my @resource_handles  = ();
my $number_of_handles = ();
my @lsrsrcapi_output = ();
my $act_rsrce         = "";
my $missing_rsrce     = "";
my $rc                = 0;

$main::Opt_ResourceExist = $FALSE;
$main::Opt_MissingRsrce  = $FALSE;
#call the lsrsrcapi command to get resource handles
($rc,@lsrsrcapi_output) = call_lsrsrcinfo_command($lsrsrcapi_opts);
if ($rc == CHARM_CLI_NO_RSRC_FOUND) {
    #printCEMsg("EMsgCHARMcliNoResourcesExists");
    #exit(CHARM_CLI_NO_RSRC_FOUND);
    $main::Opt_AllResourcesMissing = $TRUE;
    return(CHARM_CLI_NO_RSRC_FOUND);
}
# return CHARM CLI user error if it's an RMC CLI user error
($rc == CHARM_CLI_USER_ERROR) && ( error_exit(CHARM_CLI_USER_ERROR) );

# Removed on 11/01/02
# if lsrsrcapi command failed, print error message 
#if ($rc != 0) {
#    printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
#    exit(CHARM_CLI_RMC_ERROR);
#}
# parse the output from lsrsrcapi command
($main::Opt_MissingRsrce,$act_rsrce,$missing_rsrce) = parse_lsrsrcapi_outputs($Opt_SelectString,@lsrsrcapi_output);

#copy actual values from ref. to hashes
%all_resources     = %$act_rsrce;
%missing_resources = %$missing_rsrce;

# get all resource handles
@resource_handles = (keys %all_resources);
$number_of_handles = scalar @resource_handles;
# Check if any Handles exists
if ($number_of_handles > 0) {
    $main::Opt_ResourceExist = $TRUE;
    if ($number_of_handles > 1) {
       $main::Opt_TooManySource = $TRUE;
    }
} else {
    $main::Opt_AllResourcesMissing = $TRUE;
}

# Display all missing resources
if ($main::Opt_MissingRsrce){
    unless(defined $main::Opt_MissinNotReqd){
      display_missing_resources($Opt_SelectString,%missing_resources);
   } else {
      if ($main::Opt_MissinNotReqd){
          display_missing_resources($Opt_SelectString,%missing_resources);
      }
   }
}

unless(defined $main::Opt_OrderedHandles){
   return(%all_resources);
} else {
   return(\%all_resources,\@handles_ordered);
}
} #End get_resourcehandles

#--------------------------------------------------------------------#
# get_current_attribute_val - function to retreive the desired attri-#
#                             bute value from the specified class or #
#                             resource.                              #
#                                                                    #
# Parameters:                                                        #
#   $trace_opt       input    Trace Option                           #
#   $resource_class  input    Resource class                         #
#   $attr_opts       input    Desired attribute name                 #
#                                                                    #
# Return:                                                            #
#   $current_attr             Attribute string from specified        #
#                             resource or class.                     #
#                                                                    #
# Global References:                                                 #
#  $PROGNAME                   Program name                          #
#  $LSRSRCAPI                 lsrsrc RMC command                     #
#--------------------------------------------------------------------#
sub get_current_attribute_val {

my $trace_opt      = shift @_;       # Trace Option
my $select_string  = shift @_;       # select string or additional option
my $resource_class = shift @_;       # Resource Class
my $attr_opts      = shift @_;       # Desired Attribute name
my $current_attr   = "";             # Current attribute value
my $rc             = 0;              # Return code

$Trace && print STDERR "$PROGNAME: calling $LSRSRC. \n";

# List resource_name using the RMC CLI list command to see if it exists
$current_attr = `$CTBINDIR/$LSRSRC $trace_opt -x $select_string $resource_class $attr_opts`;
$rc = $?;
$rc = $rc/256;
$Trace && print STDERR "$PROGNAME: $LSRSRC returned $rc.\n";

# if lsrsrc command failed due to RMC CLI user error
# return CHARM CLI user error
   if ($rc == $RMC_CLI_USER_ERROR) {
      return(CHARM_CLI_USER_ERROR);
}

# if list command failed for other reason, print RMC error message and exit
if ($rc != 0) {
    printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
    exit(CHARM_CLI_RMC_ERROR);
} 
# return current attribute string
return $current_attr;
} #end get_current_attribute_val

#--------------------------------------------------------------------#         
# gen_new_attributelist  -    function to generate new attribute list#
#                             for the given attribute with the reso- #
#                             urce handles provided. This attribute  #
#                             is generated in a format generally used#
#                             to call the rmc chrsrc command.        #
#                                                                    #
# Parameters:                                                        #
#   $attribute_opts    input  Attributes                             #
#   @resource_hanles   input  List of Resource handles               #
#                                                                    #
# Return:                                                            #
#   $attribute_opts           Attribute string for chrsrc command.   #
#                                                                    #
# Global References:                                                 #
#                                                                    #
#--------------------------------------------------------------------#         
sub gen_new_attributelist                                                      
{                                                                              
my $attribute_name    = shift @_;            # New Attribute name
my $attribute_opts    = shift @_;            # command Attributes
my @resource_handles  = @_;                  # List of Resource Handles 
my $resource_handle   = "";                  # Resource Handle
my $count             = 0;                   # Counter
                                                                               
# Preparing for the chrsrc command                                         
$attribute_opts .= " $attribute_name" . "=\'\{";
foreach $resource_handle (@resource_handles) {                               
    if ($count != 0) {                                                     
        $attribute_opts = $attribute_opts . ",";
    }                                                                      
    $attribute_opts = $attribute_opts . $resource_handle;
    ++$count;                                                              
}                                                                          
$attribute_opts .= "\}\'";                                               

# return revised attributes 
return($attribute_opts);                                                       
}  # end gen_new_attributelist.                                                                                                                           

#--------------------------------------------------------------------#
# parse_resources  -       This function will generate the operands  #
#                          or arguements for equivalency resources   #
#                          to call the lsrsrcapi command. It will   #
#                          also parse the resources command line     #
#                          operands into respective lists of         #
#                          resource name and Nodes if possible.      #
#                                                                    #
# Input:                                                             #
#  $class              Input  Resource class name                    #
#  $select_string      Input  Selection string if any.               #
#  @resources          Input  Equivalency resources if any.          #
#                                                                    #
# Return:                                                            #
#  $resource_opts     Output  Resource operands for lsrsrcapi       #
#  @act_resource      Output  Actual resources                       #
#                                                                    #
# Global Variables used:                                             #
#   $Verbose                 Verbose mode on.                        #
#   $Trace                   Trace mode on.                          #
#   $main::Opt_SelectString  Selection String specified              #
#   $main::Opt_Resources     Equivalency resources specified         #
#--------------------------------------------------------------------#
sub parse_resources {

my $class            = shift @_;
my $select_string    = shift @_;
my (@resources)      =  @_;
my $resource         = "";
my $resource_name    = "";
my @act_resources    = ();
my $node             = "";
my $resource_opts    = " -i -e ";
my $attributes       = " -a Name::ResourceHandle ";

if ($main::Opt_SelectString) {
    $resource_opts = $resource_opts .  $attributes . " -s ";
    #$resource_opts = $resource_opts . $class . "::" . "\'$select_string\'";
    $resource_opts = $resource_opts . $class . "::" . "\"$select_string\"";
} else {
    #$resource_opts = $resource_opts .  " -o ";
    unless($main::Opt_Resources) {
        $resource_opts = $resource_opts . $attributes . " -o " . $class;
    }
    else {
        # Parsing the operand 
        foreach $resource (@resources) {
            ($resource_name,$node) = split(/:/,$resource);
            if(defined ($resource_name)){
                $resource_opts = $resource_opts ." -o " . " $class" ;
                $resource_opts = $resource_opts . "::" . "$resource_name";
                if (defined $node) { 
                    $resource_opts = $resource_opts .  "::" . $node;
                }
                push @act_resources,$resource_name;
            }
        }
    }
}
return ($resource_opts, @act_resources);
} #End of parse_resources

#--------------------------------------------------------------------#
# parse_sourceresources  - This function will generate the operands  #
#                          or arguements for both the source and tar-#
#                          get resources to call the lsrsrcapi comm-#
#                          and. It will also parse the source and    #
#                          target command line operands into respect-#
#                          ive lists of source and target resources. #
#                          The targets here are specifically for old #
#                          targets.                                  #
# Input:                                                             #
#  $source             Input  Source operand from command line       #
#  $source_string      Input  Source selection string if any.        #
#  $target             Input  Target operand from command line       #
#  $target_string      Input  Target selection string if any.        #
#                                                                    #
# Return:                                                            #
#  $source_opts       Output  Source operand for lsrsrcapi          #
#  %source_resource   Output  Source resources                       #
#  %target_resource   Output  Target resources.                      #
#                                                                    #
# Global Variables used:                                             #
#   $Verbose                 Verbose mode on.                        #
#   $Trace                   Trace mode on.                          #
#   $Opt_Source_Select       Source has selection string             #
#--------------------------------------------------------------------#
sub parse_sourceresources {

my $source           = shift @_;
my $source_string    = shift @_;
my $Opt_Select       = shift @_;
my %source_resource  = ();
my $class            = ""; 
my $prev_class       = ""; 
my $resource         = "";
my $node             = "";
my $source_opts      = " -e -i ";

# Parsing the source operand and strings
if ($Opt_Select) {
    $source_opts = $source_opts . "-a Name::ResourceHandle ";
    $source_opts = $source_opts . "-s ";
    ($class,$resource,$node) = split(/:/,$source);
    #$source_opts = $source_opts . $class . "::" ."\' $source_string\'";
    $source_opts = $source_opts . $class . "::" ."\" $source_string\"";
    $source_resource{$class} = $source_string;
} else {
    $source_opts = $source_opts . "-o ";
    ($class,$resource,$node) = split(/:/,$source);
    unless(defined $resource){
        printCEMsg("EMsgCHARMcliNoRsrcSpecified",$class);
        error_exit(CHARM_CLI_USER_ERROR);   
    } else {
        $source_opts = $source_opts . $class . "::" . $resource;
        if (defined $node) { 
            $source_opts = $source_opts .  "::" . $node;
        }
        $source_resource{$class} = $resource;
    }
}

return ($source_opts,\%source_resource);
} #End of parse_sourceresources


#--------------------------------------------------------------------#
# parse_targetresources - This function will parse the new target #
#                            command line operands into lists of tar-#
#                            get resources.                          #
#                                                                    #
# Input:                                                             #
#  $target             Input  Target operand from command line       #
#  $target_string      Input  Target selection string if any.        #
#                                                                    #
# Return:                                                            #
#  %target_resource   Output  Target resources.                      #
#                                                                    #
# Global Variables used:                                             #
#   $Verbose                 Verbose mode on.                        #
#   $Trace                   Trace mode on.                          #
#   $Opt_Target_Select       Target has selection string             #
#--------------------------------------------------------------------#
sub parse_targetresources{

my $Opt_Target_Type  = shift @_;
my $target           = shift @_;
my $target_string    = shift @_;
my $Opt_Trgt_Select  = shift @_;
my %target_resources = ();
my @resources        = ();
my $target_rsrc      = ""; 
my $class            = ""; 
my $prev_class       = ""; 
my $resource         = "";
my $node             = "";

# Parsing the target operand and strings
if ($Opt_Trgt_Select) {
    @resources = split(/,/,$target);
    foreach $target_rsrc (@resources) {
        ($class,$resource) = split(/:/,$target_rsrc, 2);
        if (($class eq "") || !defined($class)){
            $class = $prev_class;
        }
        $prev_class = $class;
        push @{$target_resources{$class}},$target_string;
    }
} else {
    @resources = split(/,/,$target);
    foreach $target_rsrc (@resources) {
        ($class,$resource) = split(/:/,$target_rsrc, 2);
        if (($class eq "") || !defined($class)){
             $class = $prev_class;
        }
        $prev_class = $class;
        unless(defined $resource){
            printCEMsg("EMsgCHARMcliNoRsrcSpecified",$class);
            error_exit(CHARM_CLI_USER_ERROR);   
         } else {
             push @{$target_resources{$class}},$resource;
         }
    }
}


return (%target_resources);
} #End of parse_newtargetresources

#--------------------------------------------------------------------#
# Check_if_src_rsrc_allowed - This function will check to see if th  #
#                         specified handle is a member resource and  #
#                         also if the source resource has a relatio- #
#                         nship already defined.                     #
#                                                                    #
# Parameters:                                                        #
#   $handle           input   Source Resource handle                 #
#                                                                    #
# Return:                                                            #
#   $ResourcesPresent Output   TRUE, if Source resource is a member  #
#                              Resource.                             #
#   $SourcePresent    Output   TRUE, if Source resource has a relat- #
#                              ionship already defined.              #
#   $target_handles   Output   target handles that match             #
#                                                                    #
# Global References:                                                 #
#   Trace             input  Trace call & return of extension.       #
#   $RSRCMGD          input  Managed Resource class.                 #
#   $RSRCREL          input  Managed Relationship class.             #
#                                                                    #
#--------------------------------------------------------------------#
sub check_if_src_rsrc_allowed {

my ($handle)           = @_;
my $actual_handle      = "";
my @resources          = ();
my $resource           = "";
my $select_string      = "";
my $lsrsrcapi_input   = "";
my $count              = 0;
my $rc                 = 0;
my $ResourcesPresent   = $FALSE;
my $SourcePresent      = $FALSE;
my $target_handles     = "";

# check if managed Resource
# generate the select string to verify if resource handle exists
$select_string = $select_string . "'";
$select_string = $select_string . "ManagedResource==$handle";
$select_string = $select_string . "'";

$lsrsrcapi_input = $lsrsrcapi_input . " -i -a ManagedResource -s $RSRCMGD". "::$select_string";

($rc,$actual_handle) = call_lsrsrcinfo_command($lsrsrcapi_input);

# return CHARM CLI user error if it's an RMC CLI user error
($rc == CHARM_CLI_USER_ERROR) && ( error_exit(CHARM_CLI_USER_ERROR) );

# If no resources are found 
if ($rc == CHARM_CLI_NO_RSRC_FOUND) {
   return ($ResourcesPresent);
} else {
  $ResourcesPresent = $TRUE;
} 
# Check if relationsip already exist 
# generate the select string to verify if resource handle exists
$select_string = "'";
$select_string = $select_string . "Source==$handle";
$select_string = $select_string . "'";

$lsrsrcapi_input = " -i -a Target -s $RSRCREL". "::$select_string";
($rc,$target_handles) = &call_lsrsrcinfo_command($lsrsrcapi_input);

# return CHARM CLI user error if it's an RMC CLI user error
($rc == CHARM_CLI_USER_ERROR) && ( error_exit(CHARM_CLI_USER_ERROR) );

# If no resources are found 
if ($rc != CHARM_CLI_NO_RSRC_FOUND) {
   $SourcePresent = $TRUE;
}

return ($ResourcesPresent,$SourcePresent,$target_handles);

} #End check_if_src_rsrc_allowed

#--------------------------------------------------------------------#
# run_list_resources  -   Function will call the call_lsrsrcinfo_com-# 
#                         mand function to run the "lsrsrcapi"      #
#                         command, inorder to list the attributes of #
#                         specified resource groups or member        #
#                         resources.                                 #
#                                                                    #
# Parameters:                                                        #
#   $passopts         input   optional flags for Trace and Verbose   #
#   $attr_opts        input   attributes to be listed                #
#   $select_string    input   select string to identify resources    #
#   $resource_class   input   class to be applied on.                #
#                                                                    #
# Return:                                                            #
#   $lsrsrcapi_output Output  output from "lsrsrcapi" command      #
#                                                                    #
# Global References:                                                 #
#   Trace             input  Trace call & return of extension.       #
#--------------------------------------------------------------------#
sub run_list_resources {

my $passopts          = shift @_;
my $attr_opts         = shift @_;
my $select_string     = shift @_;
my $resource_class    = shift @_;
my $resource_group    = shift @_;
my @lsrsrcapi_output = ();
my $info_operand      = "";
my $opt_flags         = " -n -i -a $attr_opts ";
#my $opt_flags         = " -i -a $attr_opts ";
my $lsrg_opts         = "";
my $rc                = 0;    

# for selection string and opt_flags 
if ($select_string eq "") {
    $info_operand = " -o  $resource_class"; 
}
else {
    #$info_operand = " -s $resource_class" . "::" . "\'$select_string\'"; 
    $info_operand = " -s $resource_class" . "::" . "\"$select_string\""; 
}

# put the flags and operands together
$lsrg_opts = " $opt_flags" . "$info_operand"; 


# list member resources attributes 
($rc,@lsrsrcapi_output) = call_lsrsrcinfo_command($lsrg_opts);


# exit if  CHARM CLI user error     
($rc == CHARM_CLI_USER_ERROR) && error_exit(CHARM_CLI_USER_ERROR);
if($rc == CHARM_CLI_NO_RSRC_FOUND) {
    if ($main::Opt_ResourceGroup) {
        if($main::Opt_SelectString) {
            printCEMsg("EMsgCHARMcliRGrpForQueryNotFound");
        } elsif ($main::Opt_GroupName) {
            printCEMsg("EMsgCHARMcliResourceGroupDoesNotExist", $resource_group);
        } else {
            printCEMsg("EMsgCHARMcliNoResourceGroupsExists");
        }
    } else {
        if($main::Opt_SelectString) {
            printCEMsg("EMsgCHARMcliMbrForQueryNotFound");
        } elsif ($main::Opt_GroupName) {
            printCEMsg("EMsgCHARMcliMbrRgDoesNotExist", $resource_group);
        } else {
            printCEMsg("EMsgCHARMcliNoMemberResourcesExist");
        }
    }
    exit(CHARM_CLI_NO_RSRC_FOUND);
}

# if lsrsrcapi command failed, print RMC error message 
if ($rc != 0) {
    printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
    exit(CHARM_CLI_RMC_ERROR);
}

chomp(@lsrsrcapi_output);

return @lsrsrcapi_output;
}  # End run_list_resources 

#--------------------------------------------------------------------#
# get_resource_names  -   Function will call the call_lsrsrcinfo_com-#
#                         mand function to run the "lsrsrcapi" comm-#
#                         and, inorder to get the names or class of  #
#                         specified resource handle or handles.      #
#                                                                    #
# Parameters:                                                        #
#   $resource_handles input   List of Resource Handles               #
#                                                                    #
# Return:                                                            #
#   @resource_names    Output  Resource names of handles             #
#   @resource_classes  Output  Resource classes of handles           #
#                                                                    #
# Global References:                                                 #
#   $EQUIV_ALL        input                                          #
#   $NULL             input                                          #
#--------------------------------------------------------------------#
sub get_resource_names {

my @resource_handles  = @_;
my @resource_names    = ();
my @resource_classes  = ();
my $class             = "";
my $name              = "";
my @all_equiv         = ();
my @all_nodes         = ();
my $info_operand      = "";
my @lsrsrcapi_output = ();
my $line              = "";
my $opt_flags         = " -i -m -e ";
my $lsrg_opts         = "";
my $junk              = "";
my $rc                = 0;    
my $allowed_nodes     = 0;    
my $i                 = 0;    
my $index             = 0;    
my %acthandle         = ();   
my $handle_present    = $FALSE;
my @goodhandles       =();
my $good_handle       ="";


# generate the select string

foreach $handle (@resource_handles) {
     if ($handle eq $EQUIV_ALL){
        $resource_names[$index] = $NULL;
        $resource_classes[$index] = $NULL;
        push @all_equiv, $index;
        push @goodhandles, $handle;
     } else {
        push @all_nodes, $index;
        $info_operand .= " -r \"$handle\"";
        ++$allowed_nodes;
        $acthandle{$index} = $handle;
     }
    ++$index;
} 
# put the flags and operands together
$lsrg_opts = " $opt_flags" . "$info_operand"; 

if ($allowed_nodes > 0) {

  # list member resources attributes 
  ($rc,@lsrsrcapi_output) = call_lsrsrcinfo_command($lsrg_opts);

  # exit if  CHARM CLI user error     
  #($rc == CHARM_CLI_USER_ERROR) && error_exit(CHARM_CLI_USER_ERROR);
  if($rc == CHARM_CLI_NO_RSRC_FOUND) {
     
     foreach $index(@all_nodes) {
         $resource_names[$index] = $NotResolved;
     }  
     return \@resource_names, \@resource_classes;
  }

# Removed on 11/01/02
  # if lsrsrcapi command failed, print RMC error message 
  #if ($rc != 0) {
  #   printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
  #   exit(CHARM_CLI_RMC_ERROR);
  #}

  chomp(@lsrsrcapi_output);

  foreach $output (@lsrsrcapi_output) {
     # parse each line
     ($handle,$class,$name) = split (/::/,$output);
     push @goodhandles, $handle;
     foreach $index (@all_nodes) {
        if ($handle eq $acthandle{$index}) {
            ($junk,$resource_names[$index]) = split(/"/,$name);
            ($junk,$resource_classes[$index]) = split(/"/,$class);
            #last;
        }
     }
  }
}
foreach $handle (@resource_handles) {
  
    $handle_present = $FALSE;

    foreach $good_handle (@goodhandles) {

        if ($handle eq $good_handle) {
            $handle_present = $TRUE;
            last;
        }
    }
    if ($handle_present == $FALSE){
       foreach $index (@all_nodes) {
          if ($handle eq $acthandle{$index}) {
              $resource_names[$index] = $NotResolved;
          }
       }
    }
}        
return \@resource_names, \@resource_classes;
} #End get_resource_names

#--------------------------------------------------------------------#
# translate_opstates -   Function will translate the opstate integ-  #
#                         er value to an English translation.        #
#                                                                    #
# Parameters:                                                        #
#   $opstate_value    input   Actual Opstate Integer value           #
#                                                                    #
# Return:                                                            #
#   $opstates{$opstate_value}  Output  English Transalation          #
#   "?"                        Output  Cannot be Transalated         #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_opstates {

my $opstate_value   = shift @_;
my $opstate_present = $FALSE;                             
my %opstates        = ();

# Opstate translations                     
$opstates{0} = "Unknown";                      
$opstates{1}   = "Online";                       
$opstates{2}   = "Offline";                      
$opstates{3}   = "Failed offline";               
$opstates{4}   = "Stuck online";                 
$opstates{5}   = "Pending online";               
$opstates{6}   = "Pending offline";              
$opstates{7}   = "Mixed";                        
$opstates{8}   = "Ineligible";                   
$opstates{128} = "Manual mode";                
$opstates{129} = "Online manual";              
$opstates{130} = "Offline manual";             
$opstates{131} = "Failed offline manual";      
$opstates{132} = "Stuck online manual";        
$opstates{133} = "Pending online manual";      
$opstates{134} = "Pending offline manual";     
$opstates{135} = "Mixed manual";               
                                                
# see if opstate exists                 
if (defined $opstates{$opstate_value}) {             
    $opstate_present = $TRUE;                             
}                                               
                                                
# return translated opstate                            
if ($opstate_present) {                                   
   return $opstates{$opstate_value};         
}                                            
else {                                          
   return "?";                          
}                                            
                                                
}# End translate_opstates


#--------------------------------------------------------------------#
# retreive_error      -   Function will parse the error message from #
#                         lsrsrc-api and then display it.            #
#                                                                    #
# Parameters:                                                        #
#   $err_output    input  Actual raw error message from lsrsrcapi.   #
#                                                                    #
# Return:                                                            #
#   $exit_code     Output  Exit code from lsrsrc api.                #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub retreive_error {

my $cmd_name     = shift @_;
my $err_output   = shift @_;
my $err_head     = "";
my $class        = "";
my $resource     = "";
my $exit_code    = "";
my $act_func     = "";
my $return_code  = "";
my $err_msg      = "";
my $count        = 0;
my $i            = 0;
my $junk         = "";
my $rest_of_msg  = "";
my $reqd_err_output ="";
#my $act_count    = 0;
my $act_cmd      = "";
my  $message     = "";
my ($Error,$node);

($Error,$class,$resource,$node,,$rest_of_msg) = split(/::/,$err_output,5);
$count++ while $err_output =~ /(::)/g;
$act_count = $count - 3;
$reqd_err_output = $err_output;

for($i =0;$i<$act_count;$i++){
    ($junk,$rest_of_msg) = split(/::/,$reqd_err_output,2);
    $reqd_err_output = $rest_of_msg;
}

($exit_code,$act_func, $return_code,$err_msg) = split(/::/,$reqd_err_output);
unless ($err_msg =~ /($cmd_name)/g) {
    $err_msg = "/usr/sbin/rsct/$cmd_name :" . $err_msg;
}
($act_cmd,$message)= split(/:/, $err_msg,2);

#$message =~ s/\\"/\\\$/g;
$message = replace_chars($message,"\\\\\"", "\\\$", 2);
$message =~ s/"/ /g;
#$message =~ s/\\\$/\"/g;
$message = replace_chars($message,"\\\$", "\"",1);
$message = unescape_chars($message);

#$message =~ s/\'/\\'/g;
#$err_msg = "($cmd_name) ". "$class" . ":$resource". ":$node". $message;
$err_msg = "($cmd_name)" . $message;
#printCEMsg("EMsgCHARMclisrcapiError",$err_msg);
print STDERR $err_msg;    # defect 108606
return $exit_code;
} # End retreive_error

#--------------------------------------------------------------------#         
# gen_new_attrib_list    -    function to generate new attribute list#
#                             for the given attribute with the reso- #
#                             urce handles provided. This attribute  #
#                             is generated in a format generally used#
#                             to call the chrsrc-api command.        #
#                                                                    #
# Parameters:                                                        #
#   $attribute_opts    input  Attributes                             #
#   @resource_hanles   input  List of Resource handles               #
#                                                                    #
# Return:                                                            #
#   $attribute_opts          Attribute string for chrsrc-api command.#
#                                                                    #
# Global References:                                                 #
#                                                                    #
#--------------------------------------------------------------------#         
sub gen_new_attrib_list                                                      
{                                                                              
my $attribute_name    = shift @_;            # New Attribute name
my $attribute_opts    = shift @_;            # command Attributes
my @resource_handles  = @_;                  # List of Resource Handles 
my $resource_handle   = "";                  # Resource Handle
my $count             = 0;                   # Counter
my $junk              = "";                  # Garbage 
my $handle            = "";                  # Handle without quotes.
                                                                               
# Preparing for the chrsrc command                                         
#$attribute_opts .= "::" ."$attribute_name" ."::". "\'\{";
$attribute_opts .= "::" ."$attribute_name" ."::". "\"\{";
foreach $resource_handle (@resource_handles) {                               
    if ($count != 0) {                                                     
        $attribute_opts = $attribute_opts . ",";
    }                                                                      
    #Remove the double qoutes:
    ($junk, $handle) = split(/"/,$resource_handle);
    $attribute_opts = $attribute_opts . $handle;
    ++$count;                                                              
}                                                                          
#$attribute_opts .= "\}\'";                                                    
$attribute_opts .= "\}\"";                                                    

# return revised attributes 
return($attribute_opts);                                                       
}  # end gen_new_attrib_list.                                                                                                                           
 
#--------------------------------------------------------------------#
# get_attrib_handle_list -This function will retrieve the list       #
#                         handles for the specified resource handles.#
#                                                                    #
# Parameters:                                                        #
#   $handle           input   Relationship Resource handle           #
#                                                                    #
# Return:                                                            #
#   $ResourcesPresent Output   TRUE, if Source resource is a member  #
#                              Resource.                             #
#   $SourcePresent    Output   TRUE, if Source resource has a relat- #
#                              ionship already defined.              #
#   $target_handles   Output   target handles that match             #
#                                                                    #
# Global References:                                                 #
#   Trace             input  Trace call & return of extension.       #
#   $RSRCMGD          input  Managed Resource class.                 #
#   $RSRCREL          input  Managed Relationship class.             #
#                                                                    #
#--------------------------------------------------------------------#
sub get_attrib_handle_list {

my $lsrsrcapi_input    = shift @_;
my $attrib             = "";
my @attriblist         = ();
my $rsrc_handle        = "";
my $list               = "";
my $rc                 = 0;
my $Present            = $FALSE;
my %actual_handles     = ();


# Get all target resource handles list
# generate the select string to verify if resource handle exists

($rc,@attriblist) = &call_lsrsrcinfo_command($lsrsrcapi_input);
# return CHARM CLI user error if it's an RMC CLI user error
($rc == CHARM_CLI_USER_ERROR) && ( error_exit(CHARM_CLI_USER_ERROR) );

# If resources are found 
if ($rc != CHARM_CLI_NO_RSRC_FOUND) {
   $Present = $TRUE;
}

foreach $attrib (@attriblist) {
     ($rsrc_handle,$list) = split("::",$attrib,2);
      # copy resource handles 
      $actual_handles{$rsrc_handle} = $list;
}

return ($Present,%actual_handles);
} #End get_attrib_handle_list {

#--------------------------------------------------------------------#
# chrsrcapi_resources  : Uses the Change resource RMC CLI command to #
#                        modify an already defined resources for a   #
#                        specified  class                            #
#                                                                    #
# Paramaters:                                                        #
#   $passopts           Options to pass to the RMC(Trace or Verbose) #
#   $select_string      Selection string to be passed to RMC         #
#   $resource_class     resource class name                          #
#   $attropts           Attributes to pass to the RMC                #
#                                                                    #
# Returns:                                                           #
#   $rc              return code                                     #
#                    0  if successful                                #
#                    CHARM_CLI_USER_ERROR if RMC_CLI_USER_ERROR      #
#                                                                    #
# Global Variables:                                                  #
#   $main::Trace     in case trace is on                             #
#   $main::PROGNAME  for trace message                               #
#   $CTBINDIR        where change command resides                    #
#   $RMRSRC          RMC CLI change command                          #
#--------------------------------------------------------------------#
sub chrsrcapi_resources    
{
my $SelectString     = shift @_;
my $passopts         = shift(@_);         # Trace or Verbose option flags 
my $attropts         = shift(@_);         # attributes for resource
my @chrsrcapi_output = ();      ;         # attributes for resource
my $output           = "";                # output from chrsrcapi
my $Is_Error         = "";                # Error Flag from chrsrcapi
my @new_outputs      = ();                # successful outputs from chrsrcapi
my @rest_of_output   = ();                # Garbage               
my $rc               = 0;                 # return code

my $MissingRsrce      = $FALSE;
my $act_rsrce         = "";
my $missing_rsrce     = "";
my @missing_rsrc      = ();
my %all_resources     = ();
my %missing_resources = ();
my @resource_handles  = ();
my $resource_class    = "";
my @resources         = ();
my $resource          = "";

$main::Trace && print STDERR "$main::PROGNAME: calling $CHRSRC\n";
$main::Trace && print STDERR "$CTBINDIR/$CHRSRCAPI $attropts\n";

# change the resources for the specified class, using the "chrsrc" comand       
@chrsrcapi_output = `$CTBINDIR/$CHRSRCAPI $attropts 2>&1 `;
foreach $output (@chrsrcapi_output) {
   ($Is_Error,@rest_of_output) = split(/::/,$output);
   if ($Is_Error eq "ERROR") {
       $rc = &retreive_error($CHRSRCAPI,$output);
       $main::Trace &&
            print STDERR "$main::PROGNAME: $CHRSRCAPI returned $rc\n";
       if ($rc == $RMC_CLI_USER_ERROR) {
           $rc = CHARM_CLI_USER_ERROR;
           printCEMsg("EMsgCHARMcliUserError",$rc);
       } elsif ($rc == $RMC_CLI_NO_RSRC_FOUND) {
           $rc = CHARM_CLI_NO_RSRC_FOUND;
#           printCEMsg("EMsgCHARMcliNoRsrcFound",$rc);
       } elsif ($rc != 0) {
           # if command failed for other reason, print RMC error message
           $rc =CHARM_CLI_RMC_ERROR;
           printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
       }
    } elsif ($Is_Error =~ /^$CTBINDIR/) {
       printCEMsg("EMsgCHARMclisrcapiError",$output);
    } else {
       push @new_outputs, $output;
    }
 
} # foreach

if (scalar @new_outputs > 0) {
#clear the return code if resource exists.
$rc=0;
# parse the output from chrsrcapi command
($MissingRsrce,$act_rsrce,$missing_rsrce) = parse_lsrsrcapi_outputs($SelectString,@new_outputs);

#copy actual values from ref. to hashes
%all_resources     = %$act_rsrce;
%missing_resources = %$missing_rsrce;

# get all resource handles
@resource_handles = (keys %all_resources);

# Check if any Handles exists
if ((scalar @resource_handles) <= 0) {
     $rc = CHARM_CLI_NO_RSRC_FOUND;
     $main::Trace && printCEMsg("EMsgCHARMcliNoRsrcFound",$rc);
}

# Display all missing resources
if ($MissingRsrce) {
   foreach $resource_class (keys %missing_resources){
      @resources = @{$missing_resources{$resource_class}};
      foreach $resource (@resources) {
         push @missing_rsrc, $resource;
      } # foreach $resource
   } # foreach $resource_class
}
}
# return rc
return ($rc,@missing_rsrc);

} # End chrsrcapi_resources

#--------------------------------------------------------------------#
# checkifvalidrelationship-   This function will check the validity  #
#                             of the relationship operand of the com-#
#                             command line.                          #
#                                                                    #
# Parameters:                                                        #
#   $relationship     input   Relationship value.                    #
#                                                                    #
# Return:                                                            #
#   $relationship           Output  Relationship value, if valid.    #
#   $CHARM_CLI_BAD_OPERAND  Output  Bad Operand Value.               #
#                                                                    #
# Global References:                                                 #
#                                                                    #
#--------------------------------------------------------------------#
sub checkifvalidrelationship {

my $relationship = shift @_;
my $rc           = 0;

# Make sure relationship is a number (hex, octal or decimal)
if ($relationship =~ /^(0x|\d+)\d*/) {
    # Convert relationship specified in hex or octal to decimal
    $relationship = oct($relationship) if $relationship =~ /^0/;

    # Check if specified relationship values are valid
    SWITCH: {
        ($relationship == $COLLOCATED) && last SWITCH;
        ($relationship == $ANTICOLLOCATED) && last SWITCH;
        ($relationship == $AFFINITY) && last SWITCH;
        ($relationship == $ANTIAFFINITY) && last SWITCH;
        ($relationship == $ISSTARTABLE) && last SWITCH;
        ($relationship == $STARTAFTER) && last SWITCH;
        ($relationship == $DEPENDSON) && last SWITCH;
        ($relationship == $DEPENDSONANY) && last SWITCH;
        ($relationship == $STOPSAFTER) && last SWITCH;
        ($relationship == $FORCEDDOWNBY) && last SWITCH;
        $rc = CHARM_CLI_BAD_OPERAND;
    }   # end switch
} elsif ($relationship =~ /^COLLOCATED$/i) {               # $A0
    $relationship = $COLLOCATED;
} elsif ($relationship =~ /^ANTICOLLOCATED$/i) {           # $A0
    $relationship = $ANTICOLLOCATED;
} elsif ($relationship =~ /^AFFINITY$/i) {                 # $A0
    $relationship = $AFFINITY;
} elsif ($relationship =~ /^ANTIAFFINITY$/i) {             # $A0
    $relationship = $ANTIAFFINITY;
} elsif ($relationship =~ /^ISSTARTABLE$/i) {              # $A0
    $relationship = $ISSTARTABLE;
} elsif ($relationship =~ /^STARTAFTER$/i) {               # $A0
    $relationship = $STARTAFTER;
} elsif ($relationship =~ /^DEPENDSONANY$/i) {             # $A0
    $relationship = $DEPENDSONANY;                              
} elsif ($relationship =~ /^DEPENDSON$/i) {                # $A0
    $relationship = $DEPENDSON;
} elsif ($relationship =~ /^STOPAFTER$/i) {   # Allow stopafter as well    # $A0
    $relationship = $STOPSAFTER;
} elsif ($relationship =~ /^STOPSAFTER$/i) {               # $A0
    $relationship = $STOPSAFTER;
} elsif ($relationship =~ /^FORCEDDOWNBY$/i) {             # $A0
    $relationship = $FORCEDDOWNBY;
} else {
    $rc = CHARM_CLI_BAD_OPERAND;
}
return ($rc,$relationship);
}# End checkifvalidrelationship

#--------------------------------------------------------------------#
# checkifvalidcondition   -   This function will check the validity  #
#                             of the condition operand of the command#
#                             line.                                  #
#                                                                    #
# Parameters:                                                        #
#   $condition        input   Condition value.                       #
#                                                                    #
# Return:                                                            #
#   $condition              Output  Condition value, if valid.       #
#   $CHARM_CLI_BAD_OPERAND  Output  Bad Operand Value.               #
#                                                                    #
# Global References:                                                 #
#                                                                    #
#--------------------------------------------------------------------#
sub checkifvalidcondition {

my $condition = shift @_;
my $rc        = 0;        

# Make sure condition is a number (hex, octal or decimal)
if ($condition =~ /^(0x|\d+)\d*/) {
    # Convert condition specified in hex or octal to decimal
    $condition = oct($condition) if $condition =~ /^0/;

    # Check if specified location values are valid
    SWITCH: {
        ($condition == $NOCONDITION) && last SWITCH;
        ($condition == $IFONLINE) && last SWITCH;
        ($condition == $IFOFFLINE) && last SWITCH;
        ($condition == $IFNOTONLINE) && last SWITCH;
        ($condition == $IFNOTOFFLINE) && last SWITCH;
        $rc = CHARM_CLI_BAD_OPERAND;
    }   # end switch
} elsif ($condition =~ /^NOCONDITION$/i) {        # $A0
    $condition = $NOCONDITION;
} elsif ($condition =~ /^IFONLINE$/i) {           # $A0
    $condition = $IFONLINE
} elsif ($condition =~ /^IFOFFLINE$/i) {          # $A0
    $condition = $IFOFFLINE;
} elsif ($condition =~ /^IFNOTONLINE$/i) {        # $A0
    $condition = $IFNOTONLINE;
} elsif ($condition =~ /^IFNOTOFFLINE$/i) {       # $A0
    $condition = $IFNOTOFFLINE;
} else {
    $rc = CHARM_CLI_BAD_OPERAND;
}
return ($rc,$condition);
} #End checkifvalidcondition

#--------------------------------------------------------------------#
# rmrsrcapi_resources  : Uses the rmrsrc-api command to remove one or#
#                        more already defined resources for a specif-#
#                        ied  class.                                 #
#                                                                    #
# Paramaters:                                                        #
#   $passopts           Options to pass (Trace or Verbose)           #
#   $attropts           Attributes to pass to the RMC                #
#                                                                    #
# Returns:                                                           #
#   $rc              return code                                     #
#                    0  if successful                                #
#                    CHARM_CLI_USER_ERROR if RMC_CLI_USER_ERROR      #
#                                                                    #
# Global Variables:                                                  #
#   $main::Trace     in case trace is on                             #
#   $main::PROGNAME  for trace message                               #
#   $CTBINDIR        where remove command resides                    #
#   $RMRSRCAPI       RMC API command.                                #
#--------------------------------------------------------------------#
sub rmrsrcapi_resources    
{
my $SelectString     = shift @_; 
my $passopts         = shift(@_);         # Trace or Verbose option flags 
my $attropts         = shift(@_);         # attributes for resource
my @rmrsrcapi_output = ();      ;         # attributes for resource
my $output           = "";                # output from rmrsrcapi
my $Is_Error         = "";                # Error Flag from rmrsrcapi
my @new_outputs      = ();                # successful outputs from rmrsrcapi
my @rest_of_output   = ();                # Garbage               
my $rc               = 0;                 # return code

my $MissingRsrce      = $FALSE;
my $act_rsrce         = "";
my $missing_rsrce     = "";
my @missing_rsrc      = ();
my %all_resources     = ();
my %missing_resources = ();
my @resource_handles  = ();
my $resource_class    = "";
my @resources         = ();
my $resource          = "";

$main::Trace && print STDERR "$main::PROGNAME: calling $RMRSRCAPI\n";
$main::Trace && print STDERR "$CTBINDIR/$RMRSRCAPI $attropts\n";

# remove the resources for the specified class, using the "rmrsrc-api" comand 
@rmrsrcapi_output = `$CTBINDIR/$RMRSRCAPI $attropts 2>&1 `;
foreach $output (@rmrsrcapi_output) {
   ($Is_Error,@rest_of_output) = split(/::/,$output);
   if ($Is_Error eq "ERROR") {
       $rc = &retreive_error($RMRSRCAPI,$output);
       $main::Trace &&
           print STDERR "$main::PROGNAME: $RMRSRCAPI returned $rc\n";
       if ($rc == $RMC_CLI_USER_ERROR) {
           $rc = CHARM_CLI_USER_ERROR;
           printCEMsg("EMsgCHARMcliUserError",$rc);
       } elsif ($rc == $RMC_CLI_NO_RSRC_FOUND) {
           $rc = CHARM_CLI_NO_RSRC_FOUND;
         #  printCEMsg("EMsgCHARMcliNoRsrcFound",$rc);
       } elsif ($rc != 0) {
           # if command failed for other reason, print RMC error message
           $rc =CHARM_CLI_RMC_ERROR;
           printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
       }
    } elsif ($Is_Error =~ /^$CTBINDIR/) {
       printCEMsg("EMsgCHARMclisrcapiError",$output);
    } else {
       push @new_outputs, $output;
    }
 
} # foreach
if (scalar @new_outputs > 0) {
#clear the return code if resource exists.
$rc=0;
# parse the output from rmrsrcapi command
($MissingRsrce,$act_rsrce,$missing_rsrce) = parse_lsrsrcapi_outputs($SelectString,@new_outputs);

#copy actual values from ref. to hashes
%all_resources     = %$act_rsrce;
%missing_resources = %$missing_rsrce;

# get all resource handles
@resource_handles = (keys %all_resources);

# Check if any Handles exists
if ((scalar @resource_handles) <= 0) {
     $rc = CHARM_CLI_NO_RSRC_FOUND;
     $main::Trace && printCEMsg("EMsgCHARMcliNoRsrcFound",$rc);
}

# Display all missing resources
if ($MissingRsrce) {
   foreach $resource_class (keys %missing_resources){
      @resources = @{$missing_resources{$resource_class}};
      foreach $resource (@resources) {
         push @missing_rsrc, $resource;
      } # foreach $resource
   } # foreach $resource_class
}
}
# return rc
return ($rc,@missing_rsrc);

} # End rmrsrcapi_resources

#--------------------------------------------------------------------#
# mkrsrcapi_resources  : Uses the mkrsrc-api command to make one or  #
#                        more resources for a specified  class.      #
#                                                                    #
# Paramaters:                                                        #
#   $passopts           Options to pass (Trace or Verbose)           #
#   $attropts           Attributes to pass to the RMC                #
#                                                                    #
# Returns:                                                           #
#   $rc              return code                                     #
#                    0  if successful                                #
#                    CHARM_CLI_USER_ERROR if RMC_CLI_USER_ERROR      #
#   @Rnew_output     All successfully defined handles                #
#                                                                    #
# Global Variables:                                                  #
#   $main::Trace     in case trace is on                             #
#   $main::PROGNAME  for trace message                               #
#   $CTBINDIR        where change command resides                    #
#   $MKRSRCAPI       RMC CLI change command                          #
#--------------------------------------------------------------------#
sub mkrsrcapi_resources    
{
my $passopts         = shift(@_);         # Trace or Verbose option flags 
my $attropts         = shift(@_);         # attributes for resource
my @mkrsrcapi_output = ();      ;         # attributes for resource
my $output           = "";                # output from mkrsrcapi
my $Is_Error         = "";                # Error Flag from mkrsrcapi
my @new_outputs      = ();                # successful outputs from mkrsrcapi
my @rest_of_output   = ();                # Garbage               
my $rc               = 0;                 # return code
my $count            = 0;                 # counter    

$main::Trace && print STDERR "$main::PROGNAME: calling $MKRSRCAPI\n";
$main::Trace && print STDERR "$CTBINDIR/$MKRSRCAPI $attropts\n";

# define the resources for the specified class, using the "mkrsrc-api" comand 
@mkrsrcapi_output = `$CTBINDIR/$MKRSRCAPI $attropts 2>&1 `;
foreach $output (@mkrsrcapi_output) {
   ($Is_Error,@rest_of_output) = split(/::/,$output);
   if ($Is_Error eq "ERROR") {
       $rc = &retreive_error($MKRSRCAPI,$output);
       $main::Trace &&
           print STDERR "$main::PROGNAME: $MKRSRCAPI returned $rc\n";
       if ($rc == $RMC_CLI_USER_ERROR) {
           $rc = CHARM_CLI_USER_ERROR;
           printCEMsg("EMsgCHARMcliUserError",$rc);
       } elsif ($rc == $RMC_CLI_NO_RSRC_FOUND) {
           $rc = CHARM_CLI_NO_RSRC_FOUND;
           printCEMsg("EMsgCHARMcliNoRsrcFound",$rc);
       } elsif ($rc != 0) {
           # if list command failed for other reason, print RMC error message
           $rc =CHARM_CLI_RMC_ERROR;
           printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
       }
    } elsif ($Is_Error =~ /^$CTBINDIR/) {
       printCEMsg("EMsgCHARMclisrcapiError",$output);
    } else {
       push @new_output, $output;
    }
 
} # foreach
if (scalar @new_outputs > 0) {
   #clear the return code if resource exists.
   $rc=0;
}
# return rc
return ($rc,@new_output);

} # End mkrsrcapi_resources
#--------------------------------------------------------------------#
# run_list_attributes -   Function will call the call_lsrsrcinfo_com-# 
#                         mand function to run the "lsrsrcapi"       #
#                         command, inorder to list the attributes of #
#                         specified classes.                         #
#                                                                    #
# Parameters:                                                        #
#   $passopts         input   optional flags for Trace and Verbose   #
#   $attr_opts        input   attributes to be listed                #
#   $info_operand     input   operands to list attributes if any     #
#   @handles          input   ResourceHandles to identify relations  #
#                                                                    #
# Return:                                                            #
#   $lsrsrcapi_output Output  output from "lsrsrcapi" command        #
#   $rc               Output  Return code                            #
#                                                                    #
# Global References:                                                 #
#   Trace             input  Trace call & return of extension.       #
#--------------------------------------------------------------------#
sub run_list_attributes {

my $passopts          = shift @_;
my $attr_opts         = shift @_;
my $info_operand      = shift @_;
#my @handles           = @_;
my @lsrsrcapi_output  = ();
my $opt_flags         = " -n -i -a $attr_opts ";
my $lsrg_opts         = "";
my $rc                = 0;    


# put the flags and operands together
$lsrg_opts = " $opt_flags" . "$info_operand"; 


# list resource attributes 
($rc,@lsrsrcapi_output) = call_lsrsrcinfo_command($lsrg_opts);

# exit if  CHARM CLI user error     
($rc == CHARM_CLI_USER_ERROR) && error_exit(CHARM_CLI_USER_ERROR);

# Removed on 11/01/02
# if lsrsrcapi command failed, print RMC error message 
#if (($rc != 0) && ($rc != CHARM_CLI_NO_RSRC_FOUND)) {
#    printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
#    exit(CHARM_CLI_RMC_ERROR);
#}

chomp(@lsrsrcapi_output);

return ($rc,@lsrsrcapi_output);
} # End run_list_attributes

#--------------------------------------------------------------------#
# translate_relations -  Function will translate the relationship in-#
#                        teger value to an English translation.      #
#                                                                    #
# Parameters:                                                        #
#   $relation_value    input   Actual Relationship Integer value     #
#                                                                    #
# Return:                                                            #
#   $relationship{relation_value} Output English Transalation        #
#   "?"                           Output  Cannot be Transalated      #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_relations{

my $relation_value  = shift @_;
my $relation_present= $FALSE;                             
my %relationship    = ();

# Relationship translations                     
$relationship{$COLLOCATED}     = "Collocated";
$relationship{$ANTICOLLOCATED} = "AntiCollocated";
$relationship{$AFFINITY}       = "Affinity";
$relationship{$ANTIAFFINITY}   = "AntiAffinity";
$relationship{$ISSTARTABLE}    = "IsStartable";
$relationship{$STARTAFTER}     = "StartAfter";
$relationship{$DEPENDSON}      = "DependsOn";
$relationship{$DEPENDSONANY}   = "DependsOnAny";
$relationship{$STOPSAFTER}     = "StopAfter";
$relationship{$FORCEDDOWNBY}    = "ForcedDownBy";
                                                
# see if relationship exists                 
if (defined $relationship{$relation_value}) {             
    $relation_present = $TRUE;                             
}                                               
                                                
# return translated relationship                            
if ($relation_present) {                                   
   return $relationship{$relation_value};         
}                                            
else {                                          
   return "?";                          
}                                            
                                                
}# End translate_relations

#--------------------------------------------------------------------#
# translate_conditions - Function will translate the conditional  in-#
#                        teger value to an English translation.      #
#                                                                    #
# Parameters:                                                        #
#   $conditon_value    input   Actual conditional  Integer value     #
#                                                                    #
# Return:                                                            #
#   $conditional{condition_value} Output English Transalation        #
#   "?"                           Output  Cannot be Transalated      #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_conditions {

my $condition_value  = shift @_;
my $condition_present= $FALSE;                             
my %condition    = ();

# Conditional translations                     
$condition{$NOCONDITION} = "NoCondition";
$condition{$IFONLINE}    = "IfOnline";
$condition{$IFOFFLINE}   = "IfOffline";
$condition{$IFNOTONLINE} = "IfNotOnline";
$condition{$IFNOTOFFLINE}= "IfNotOffline";
                                                
# see if Condition exists                 
if (defined $condition{$condition_value}) {             
    $condition_present = $TRUE;                             
}                                               
                                                
# return translated relationship                            
if ($condition_present) {                                   
   return $condition{$condition_value};         
}                                            
else {                                          
   return "?";                          
}                                            
                                                
}# End translate_conditions

#--------------------------------------------------------------------#
# charm_cli_timestamp  - Function will record the date and time of   #
#                        when a CLI command was invoked in a log.    #
#                                                                    #
# Parameters:                                                        #
#   $Prgname      input   Name of Program or command                 # 
#   $date         input   Date and time when command was invoked.    # 
#   @arguements   input   Actual command arguements.                 # 
#                                                                    #
# Return:                                                            #
#                                                                    #
# Global References:                                                 #
#   $RMGR_LOG     Location and name of log file.                     # 
#--------------------------------------------------------------------#
sub charm_cli_timestamp {

my $Prgname      = shift @_;
my $date         = shift @_;
my @arguements   = @_;

open (HANDLE, ">> $RMGR_LOG") || printCEMsg("IMsgCHARMcliFileOpenError", $RMGR_LOG);

if ($#arguements < 0) {
   print HANDLE "\"$Prgname\"  command invoked at $date\n";
}
else {
   print HANDLE "\"$Prgname @arguements\" command invoked at $date\n";
}

} # End charm_cli_timestamp

#--------------------------------------------------------------------#
# translate_policies   - Function will translate the equivalency pol-#
#                        icies value to an English translation.      #
#                                                                    #
# Parameters:                                                        #
#   $policy_value      input   Actual conditional  Integer value     #
#                                                                    #
# Return:                                                            #
#   $policy{policy_value}   Output  English Transalation             #
#   "?"                     Output  Cannot be Transalated            #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_policies {

my $policy_value  = shift @_;
my $policy_present= $FALSE;                             
my %policy    = ();

# policy translations                     
$policy{$ANY}        = "ANY";
$policy{$ORDERED}    = "ORDERED";
$policy{$ROUNDROBIN} = "ROUNDROBIN";
                                                
# see if policy exists                 
if (defined $policy{$policy_value}) {             
    $policy_present = $TRUE;                             
}                                               
                                                
# return translated relationship                            
if ($policy_present) {                                   
   return $policy{$policy_value};         
}                                            
else {                                          
   return "?";                          
}                                            
                                                
}# End translate_policies

#--------------------------------------------------------------------#
# Rsrc_Is_Fixed        - Function will return TRUE if the resource   #
#                        is a fixed resource.                        #
#                                                                    #
# Parameters:                                                        #
#   $handle            input   Actual resource handle                #
#                                                                    #
# Return:                                                            #
#   $TRUE /$FALSE      Output  TRUE if Fixed and FALSE if not        #
#                                                                    #
# Global References:                                                 #
# $RMC_RSRC_HNDL_TYPE_FIXED                                          #
# $RMC_RSRC_HNDL_TYPE_MASK                                           #
#--------------------------------------------------------------------#
sub Rsrc_Is_Fixed {

my $handle  = shift @_;
my $hdl_hdr = 0;
my $junk    = "";
my $tmp_hdr = 0x0000;
                                                
($hdl_hdr,$junk)  = split(" ",$handle);
# convert string to hexadecimal value
$tmp_hdr = hex($hdl_hdr);

# Check to see if Fixed
$Act_Mask = ($tmp_hdr & $RMC_RSRC_HNDL_TYPE_MASK);

# If fixed
if($Act_Mask == $RMC_RSRC_HNDL_TYPE_FIXED){
    return $TRUE;
}
return $FALSE;
} #Rsrc_Is_Fixed

#--------------------------------------------------------------------#
# get_resource_attributes-Function will call the call_lsrsrcinfo_com-#
#                         mand function to run the "lsrsrcapi" comm- #
#                         and, inorder to get the desired attributes #
#                         for the specified resource handle ,handles.#
#                         or resources.                              #
#                                                                    #
# Parameters:                                                        #
#   $attribute        input   Actual attributes to be got            #
#   $resource_handles input   List of Resource Handles               #
#                                                                    #
# Return:                                                            #
#   @attributes        Output  Desired output of attributes for      #
#                              Resource handles.                     #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub get_resource_attributes {

my $Opt_Handles       = shift @_;
my $act_attribute     = shift @_;
my @resource_handles  = @_;
my @attributes        = ();
my @indexes           = ();
my %acthandle         = ();   
my @lsrsrcapi_output = ();
my $info_operand      = "";
my $output            = "";
my $lsrg_opts         = "";
my $junk              = "";
my $opt_flags         = " -i -e ";
my $rc                = 0;    
my $index             = 0;    
my $attribute         = "";   


if ($Opt_Handles) {
   foreach $handle (@resource_handles) {
       push @indexes, $index;
       $info_operand .= " -r \"$handle\"::$act_attribute";
       $acthandle{$index} = $handle;
       ++$index;
   } 
} else {
       $info_operand = $act_attribute;
}

# put the flags and operands together
$lsrg_opts = " $opt_flags" . "$info_operand"; 

if (($index > 0)||(!$Opt_Handles)) {

      # list member resources attributes 
      ($rc,@lsrsrcapi_output) = call_lsrsrcinfo_command($lsrg_opts);

      # exit if  CHARM CLI user error     
      #($rc == CHARM_CLI_USER_ERROR) && error_exit(CHARM_CLI_USER_ERROR);

# Removed on 11/01/02
      # if lsrsrcapi command failed, print RMC error message
      #if (($rc != 0)&& ($rc != CHARM_CLI_NO_RSRC_FOUND)){
      # printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
      # exit(CHARM_CLI_RMC_ERROR);
      #}

      chomp(@lsrsrcapi_output);

      unless($Opt_Handles) {
         return @lsrsrcapi_output; 
      }
      foreach $output (@lsrsrcapi_output) {
         # parse each line
         ($handle,$attribute) = split (/::/,$output);
         foreach $index (@indexes) {
            if ($handle eq $acthandle{$index}) {
               $attributes[$index] = $attribute; 
            }
         }
      }
}
   
return @attributes;
} #End get_resource_attributes

#--------------------------------------------------------------------#
# runactapi_resources  - Function will perform the action specified  #
#                        by the command.                             #
#                                                                    #
# Parameters:                                                        #
#   $runact_opts       input   Actual Action parameter               #
#                                                                    #
# Return:                                                            #
#   $success           Output  TRUE if success.                      #
#                      Output  FAILURE if unscuuccessful             #  
# Global References:                                                 #
#--------------------------------------------------------------------#
sub runactapi_resources {

my $passopts         = shift @_;
my $runact_opts      = shift @_;
my $runactapi_output = "";
my $output           = "";                # output from runactapi
my $Is_Error         = "";                # Error Flag from runactapi
my @new_outputs      = ();                # successful outputs from runactapi
my @rest_of_output   = ();                # Garbage               
my $rc               = 0;                 # return code

$main::Trace && print STDERR "$main::PROGNAME: calling $RUNACTAPI\n";
$main::Trace && print STDERR "$CTBINDIR/$RUNACTAPI $runact_opts\n";

# change the resources for the specified class, using the "runact-api"          
$output = `$CTBINDIR/$RUNACTAPI $runact_opts 2>&1 `;

   ($Is_Error,@rest_of_output) = split(/::/,$output);
   if ($Is_Error eq "ERROR") {
       $rc = &retreive_error($RUNACTAPI,$output);
       $main::Trace &&
            print STDERR "$main::PROGNAME: $RUNACTAPI returned $rc\n";
       if ($rc == $RMC_CLI_USER_ERROR) {
           $rc = CHARM_CLI_USER_ERROR;
           printCEMsg("EMsgCHARMcliUserError",$rc);
       } elsif ($rc == $RMC_CLI_NO_RSRC_FOUND) {
           $rc = CHARM_CLI_NO_RSRC_FOUND;
       } elsif ($rc != 0) {
           # if command failed for other reason, print RMC error message
           $rc =CHARM_CLI_RMC_ERROR;
           printCEMsg("EMsgCHARMcliUnExpectRMCrc",$rc);
       }
    } elsif ($Is_Error =~ /^$CTBINDIR/) {
       printCEMsg("EMsgCHARMclisrcapiError",$output);
       $rc = CHARM_CLI_RMC_ERROR;
    } #else {
       #push @new_outputs, $output;
      # $rc = $TRUE;
    #}
    return ($rc,$output); 
} # end runactapi_resources

#--------------------------------------------------------------------#
# get_fixed_nodenames    -Function will call the Rsrc_Is_Fixed funct-#
#                         ion to determine if handles(resources) are #
#                         fixed. Once fixed handles are found then   #
#                         the node names that they are located at are#
#                         determined by calling get_resource_attribu-#
#                         te function.                               #
#                                                                    #
# Parameters:                                                        #
#   $Opt_Handles      input   Option indicating Resource Handles.    #
#   $resource_handles input   List of Resource Handles               #
#                                                                    #
# Return:                                                            #
#   @act_nodes         Output  All the found node names of any fixed #
#                              Resource handles.                     #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub get_fixed_nodenames {

my $Opt_Handles       = shift @_;
my @resource_handles  = @_;
my $act_attribute     = "NodeNameList";
my @fixed_handles     = ();
my @fixed_nodes       = ();
my @act_nodes         = ();
my @indexes           = ();
my $handle            = 0;    
my $act_handle        = 0;    
my $index             = 0;    
my $attribute         = "";   
my $node              = "";   
my $i                 = 0;    


foreach $handle (@resource_handles){
  
   if(&Rsrc_Is_Fixed($handle)){
       push @fixed_handles, $handle;
       push @indexes, $index;
   }
   ++$index;
}

if (scalar @fixed_handles > 0) {
   @fixed_nodes = &get_resource_attributes($Opt_Handles,$act_attribute,@fixed_handles);

   foreach $node (@fixed_nodes) {
      my ($junk, $nodename) = split(/[{}]/,$node);
      $act_nodes[$indexes[$i]] = $nodename;
      ++$i;
   }
}
   
return @act_nodes;
} #End get_fixed_nodenames    

#--------------------------------------------------------------------#
# allowednodeiswhat     - function will check to see if the allowed  #
#                         node of a resource group is an equivalency #
#                         or a just a single node. It will then      #
#                         return the allowed nodes NodeNameList.     #
#                                                                    #
# Parameters:                                                        #
#   @resource_handles input   Resource handles of allowed nodes      #
#                                                                    #
#                                                                    #
# Return:                                                            #
#   @handles              Returns the node name list of allowed nodes#
#                                                                    #
#                                                                    #
# Global References:                                                 #
#   Trace             input   Trace call & return of extension.      #
#                                                                    #
#--------------------------------------------------------------------#
sub allowednodeiswhat     
{
my (@resource_handles)    = @_;
my $attrib_opts           = "";
my $handle                = "";
my @handles               = ();
my @node_handles          = ();
my $class                 = "";
my $Opt_Handles           = $TRUE;
my @resource_names        = ();
my @resource_classes      = ();
my ($resource_ref,$class_ref);
my ($nodenamelist,@nodelists);

($resource_ref,$class_ref) = get_resource_names(@resource_handles);
 #copy data from ref pointers
@resource_names = @$resource_ref;
($class,@resource_classes) = @$class_ref;
#unless($class eq  "IBM.Equivalency"){
unless($class eq  $RSRCEQU){
    $attrib_opts = "NodeNameList";
} else {
    $attrib_opts = "Membership";
}
($nodenamelist,@nodelists) = get_resource_attributes($Opt_Handles,$attrib_opts,@resource_handles);

$nodenamelist =~ s/{//g;
$nodenamelist =~ s/}//g;
@node_handles = split(",",$nodenamelist);
if($class eq  $RSRCEQU){
     (@handles) = get_resource_attributes($Opt_Handles,"NodeNameList",@node_handles);
   
     @node_handles =();
     foreach $handle (@handles){
         $handle =~ s/{//g;
         $handle =~ s/}//g;
         @nodelists = split(",",$handle);
         push @node_handles, @nodelists;
     }
}

@handles = @node_handles;
return @handles;
}
#--------------------------------------------------------------------#
# check_if_member_is_allowed    -  This function will check if the   #
#                                  members are from the allowed nodes#
#                                  of its new resource group.        #
#                                                                    #
# Parameters:                                                        #
#  $resource_group      input   Resource group                       #
#  $resource_handles    input   Resource handles of member resources #
#  $nodenamelist        input   Allowed Node Name list               #
#                                                                    #
# Return:                                                            #
#  @new_handles       output    Resource handles of members that can #
#                               be a member of te specified resource #
#                               group.                               #
#                                                                    #
#                                                                    #
# Global References:                                                 #
#   Trace             input   Trace call & return of extension.      #
#                                                                    #
#--------------------------------------------------------------------#
sub check_if_members_are_allowed{

my $resource_group      = shift @_;
my $resource_handles    = shift @_;
my $nodenamelist        = shift @_;
my @resource_handles    = @$resource_handles;
my @nodenamelist        = @$nodenamelist;
my $Opt_Handles         = TRUE;     
my $resource_ref        = "";
my $class_ref           = "";
my @resource_names      = ();
my @resource_classes    = ();
my @handles             = ();
my $count               = 0;
my @nodelists           = ();
my $act_node            = "";
my @act_node_list       = ();
my %seen                = ();
my %tpgrp               = ();
my @new_handles         = ();
my $NotFound            = $FALSE;
my $Found               = $FALSE;
#my @node                = ();
my @act_node            = ();
my @res_handles         = ();
my $handle              = "";
my $tmp_handle          = "";


# remove double quotes.
foreach $handle (@resource_handles) {
    $tmp_handle = $handle;
    $tmp_handle =~ s/"//g;
    push @res_handles, $tmp_handle;
}
# check if it is a resource or a group
($resource_ref,$class_ref) = get_resource_names(@res_handles);
#copy data from ref pointers
@resource_names = @$resource_ref;
@resource_classes = @$class_ref;
foreach $class (@resource_classes){
    $NotFound = $FALSE; 
    $Found = $FALSE; 
    @handles = ();
    push @handles, $res_handles[$count];
    if( $class eq $RSRCGRP){


        $Opt_Handles = $TRUE;
        (@nodelists) = get_resource_attributes($Opt_Handles,"AllowedNode",@handles);
        ($nodenamelist,@act_node) = @nodelists;  
        # get the NodeNameList of available handles if resource
        # or allowed node list if group
        if( $nodenamelist eq $EQUIV_ALL){
             $act_attribute = " -a NodeNameList -o IBM.PeerNode";
             $Opt_Handles = $FALSE;
             (@act_node) = get_resource_attributes($Opt_Handles,$act_attribute,@handles);
             @handles =();
             foreach $handle (@act_node){
                  $handle =~ s/{//g;
                  $handle =~ s/}//g;
                  $handle =~ s/IBM.PeerNode:://g;
                  @nodelists = split(",",$handle);
                  push @handles, @nodelists;
              }
              @act_node = @handles;
         } else { 
             (@act_node) = &allowednodeiswhat(@nodelists);
         }  
         #check if allowed node is in parent rgroups allowed node
   
         # Building lookup table
         @seen{@nodenamelist} = ();

         foreach $act_node (@act_node) {
             if (exists($seen{"$act_node"})){
                 $Found = $TRUE;
                 last;
             }
         }
         unless($Found){
             $main::Opt_MissingRsrce = $TRUE;
             printCEMsg("EMsgCHARMcliNotAllowedResources",$resource_names[$count],$resource_classes[$count], $resource_group);
         } else {
            # Check if it is common to Top Group
            # Get top Group
            # command syntax to find allowed nodes
            $act_attribute       = "-a TopGroup -o $RSRCGRP" ."::\"$resource_group\"";
            $Opt_Handles = $FALSE;
            # check for Resource Groups
            my($topgroup,@topgroup) = get_resource_attributes($Opt_Handles,$act_attribute,@resource_handles);

            # get class name, resource name and allowednode
            my($class,$res,$alnode) = split("::",$topgroup);

            $topgroup = $alnode;
            $topgroup =~ s/"//g;
            unless (($topgroup eq $resource_group)||($topgroup eq "")){
               # command syntax to find allowed nodes
               $act_attribute       = "-a AllowedNode -o $RSRCGRP" ."::\"$topgroup\"";
               # check for Resource Groups
               my ($allowednode,@allowednode) = get_resource_attributes($Opt_Handles,$act_attribute,@resource_handles);

               # get class name, resource name and allowednode
               ($class,$res,$alnode) = split("::",$allowednode);
        
               if( $alnode eq $EQUIV_ALL){
                   $act_attribute = " -a NodeNameList -o IBM.PeerNode";
                   $Opt_Handles = $FALSE;
                   my(@tpgrp_node) = get_resource_attributes($Opt_Handles,$act_attribute,@handles);
                   @handles =();
                   foreach $handle (@tpgrp_node){
                       $handle =~ s/{//g;
                       $handle =~ s/}//g;
                       $handle =~ s/IBM.PeerNode:://g;
                       @nodelists = split(",",$handle);
                       push @handles, @nodelists;
                   }
                   @tpgrp_node = @handles;
               } else { 
                  @nodelists = ();
                  push @nodelists, $alnode;
                  (@tpgrp_node) = &allowednodeiswhat(@nodelists);
               }  
               # Building lookup table
               @tpgrp{@tpgrp_node} = ();

               $Found = $FALSE; 
               foreach $act_node (@act_node) {
                  if (exists($tpgrp{"$act_node"})){
                      $Found = $TRUE;
                      last;
                  }
               }
               unless($Found){
                   $main::Opt_MissingRsrce = $TRUE;
                   printCEMsg("EMsgCHARMcliTopGroupNotAllowedResources",$resource_names[$count],$resource_classes[$count], $topgroup);
               } else {
                    # if it is add this handle to resourchandle for adding
                    push @new_handles, "\"$res_handles[$count]\"";
               }
            } else {
                 # if it is add this handle to resourchandle for adding
                 push @new_handles, "\"$res_handles[$count]\"";
            }
        }
    }else {  # If Member is not a ResourceGroup
        $Opt_Handles = $TRUE;
        ($act_node,@nodelists) = get_resource_attributes($Opt_Handles,"NodeNameList",@handles);
        $act_node =~ s/{//g;
        $act_node =~ s/}//g;
        @act_node = split(",",$act_node);
        # Building lookup table
        @seen{@nodenamelist} = ();

        foreach $act_node (@act_node) {
           if (exists($seen{"$act_node"})){
               $Found = $TRUE;
               last;
           }
        }
        if (!$Found){
           $main::Opt_MissingRsrce = $TRUE;
           printCEMsg("EMsgCHARMcliNotAllowedResources",$resource_names[$count],$resource_classes[$count],$resource_group);

        } else {
           push @new_handles, "\"$res_handles[$count]\"";
        }   
    
        #check if handle is in parent rgroups allowed node
        # if it is add this handle to resourchandle for adding
    }
    ++$count;
} #foreach $class
return @new_handles;
} # End check_if_members_are_allowed

#--------------------------------------------------------------------#
# replace_chars                                                      #
#   Scans a string respecting multibyte encodings to replace specif- #
#   characters with its replacement characters.                      #
#                                                                    #
# Paramaters:                                                        #
#   $string_in      string to check for                              #
#   $substr1        Actual characters to be searched and replaced.   #
#   $substr2        replacement characters or strings.               #
#   $str1len        string to check for any needed escapes.          #
#                                                                    #
# Returns:                                                           #
#   $string_out     result.                                          #
#                                                                    #
#--------------------------------------------------------------------#
sub replace_chars
{
use POSIX;
use POSIX qw(:stdlib_h);
use POSIX qw(mblen);
my $string_in = shift(@_);
my $substr1   = shift(@_);
my $substr2   = shift(@_);
my $str1len   = shift(@_);
my $string_in2 = "";
my $string_out = "";
my $lenstring = 0;
my $lenchar = 0;

# escape any single character backslashes (\)
$lenstring = length($string_in);

# if there are none, skip over checking char-by-char
if ($string_in =~ /.*\\.*/) {

   for (my $i=0; $i<$lenstring; $i+=$lenchar) {

      # form the string of where we're at
      $string_in2 = substr($string_in,$i);

      # determine if this is a multibyte encoding (mblen>1)
      $lenchar = mblen ($string_in2, MB_CUR_MAX);

      # if it's length is less than 1, treat it as 1 character
      if (!$lenchar >= 1) { $lenchar = 1;}
      # if it's not multibyte and it's a backslash, escape it
      if ( ($lenchar == 1) && ($string_in2 =~ /^$substr1/) ) {
         $lenchar = $str1len;
         $string_out .= $substr2;
      }

      # otherwise, just take it as it is
      else {$string_out .= substr($string_in2,0,$lenchar);}

   }

}

# it doesn't have a backslash at all so take it as is
else {$string_out = $string_in;}

# going to put double quotes around the whole thing so
# escape any inner quotes
#$string_out =~ s/\"/\\\"/g;


return ($string_out);
}   # end replace_char

#--------------------------------------------------------------------#
# unescape_chars:                                                    #
#   Scans a string respecting multibyte encodings to change an       #
#   escaped double quote (\") to a double quote (").                 #
#                                                                    #
# Paramaters:                                                        #
#   $string_in      string to check for escaped double quotes.       #
#                                                                    #
# Returns:                                                           #
#   $string_out     result.                                          #
#                                                                    #
#--------------------------------------------------------------------#
sub unescape_chars
{
use POSIX;
use POSIX qw(:stdlib_h);
use POSIX qw(mblen);
my $string_in = shift(@_);
my $string_in2 = "";
my $string_out = "";
my $lenstring = 0;
my $lenchar = 0;

# escape any single character backslashes (\)
$lenstring = length($string_in);

# if there are none, skip over checking char-by-char
if ($string_in =~ /.*\\.*/) {

   for (my $i=0; $i<$lenstring; $i+=$lenchar) {

      # form the string of where we're at
      $string_in2 = substr($string_in,$i);

      # determine if this is a multibyte encoding (mblen>1)
      $lenchar = mblen ($string_in2, MB_CUR_MAX);

      # if it's length is less than 1, treat it as 1 character
      if (!$lenchar >= 1) { $lenchar = 1;}

      # if it's not multibyte and it's a backslash, escape it
      if ( ($lenchar == 1) && ($string_in2 =~ /^\\\"/) ) {
         $string_out .= "\"";
         $lenchar++;
      }

      # otherwise, just take it as it is
      else {$string_out .= substr($string_in2,0,$lenchar);}

   }

}

# it doesn't have a backslash at all so take it as is
else {$string_out = $string_in;}

return ($string_out);
}   # end unescape_char

#--------------------------------------------------------------------#
# escape_chars:                                                      #
#   Scans a string respecting multibyte encodings to add escapes     #
#   to backslashes (\) and double quotes (").                        #
#                                                                    #
# Paramaters:                                                        #
#   $string_in      string to check for any needed escapes.          #
#                                                                    #
# Returns:                                                           #
#   $string_out     result.                                          #
#                                                                    #
#--------------------------------------------------------------------#
sub escape_chars
{
use POSIX;
use POSIX qw(:stdlib_h);
use POSIX qw(mblen);
my $string_in = shift(@_);
my $string_in2 = "";
my $string_out = "";
my $lenstring = 0;
my $lenchar = 0;
                                                                                                                             
# escape any single character backslashes (\)
$lenstring = length($string_in);
                                                                                                                             
# if there are none, skip over checking char-by-char
if ($string_in =~ /.*\\.*/) {
                                                                                                                             
   for (my $i=0; $i<$lenstring; $i+=$lenchar) {
                                                                                                                             
      # form the string of where we're at
      $string_in2 = substr($string_in,$i);
                                                                                                                             
      # determine if this is a multibyte encoding (mblen>1)
      $lenchar = mblen ($string_in2, MB_CUR_MAX);
                                                                                                                             
      # if it's length is less than 1, treat it as 1 character
      if (!$lenchar >= 1) { $lenchar = 1;}
                                                                                                                             
      # if it's not multibyte and it's a backslash, escape it
      if ( ($lenchar == 1) && ($string_in2 =~ /^\\/) ) {
         $string_out .= "\\\\";
      }                                                                                                                       
      else {$string_out .= substr($string_in2,0,$lenchar);}
 
   }
 
}
 
# it doesn't have a backslash at all so take it as is
else {$string_out = $string_in;}
 
# going to put double quotes around the whole thing so
# escape any inner quotes
$string_out =~ s/\"/\\\"/g;

 
 
return ($string_out);
}   # end escape_char

#--------------------------------------------------------------------#
# getIMsg : calls $LSMSG to print out the message with the           #
#   required parameters, like printIMsg, except the message is       #
#   returned instead of printed.  Used for NLS.                      #
#                                                                    #
# Parameters:                                                        #
#   msg       in  Message mnemonic / message number in a sense.      #
#   optargs   in  Extra arguments/parameters to send to LSMSG.       #
#                                                                    #
# Returns:                                                           #
#   msgtext   out Array of messages.                                 #
#                                                                    #
# Global Variables:                                                  #
#   $main::Trace    in  Print extra info when trace is on.           #
#   $main::PROGNAME in  Calling program/command for error message.   #
#   $main::LSMSG    in  Path & Command to display messages.          #
#   $main::MSGCAT   in  The calling commands Message catalogue.      #
#--------------------------------------------------------------------#
sub getIMsg
{
my ($msg, @optargs) = @_;
my ($optarg, $optargs);
my @msgtext = ();

$main::Trace &&
    print STDERR "$main::LSMSG $main::PROGNAME $main::MSGCAT $msg @optargs\n";

# Keep the args to LSMSG separate by separating with single quotes
# but must replace internal single quotes with blanks or get an error.
# Must escape internal double quotes for the system call.
foreach $optarg (@optargs) {
    $optarg =~ s/'/ /g;
    $optarg =~ s/"/\\"/g;
}
$optargs = "'" . join("' '",@optargs) . "'";

if (scalar @optargs > 0) {
     @msgtext = `$main::LSMSG $main::PROGNAME $main::MSGCAT $msg $optargs`;
}
else {
     @msgtext = `$main::LSMSG $main::PROGNAME $main::MSGCAT $msg`;
}

return (@msgtext);
}   # end getIMsg

#--------------------------------------------------------------------#
# End Exported Subroutines (with @EXPORT_OK, -> on demand).          #
#--------------------------------------------------------------------#

#--------------------------------------------------------------------#
# End File.                                                          #
#--------------------------------------------------------------------#
